LUI.UICountdown = InheritFrom( LUI.UIElement )
LUI.UICountdown.build = function ( f1_arg0, f1_arg1 )
	return LUI.UICountdown.new( f1_arg1 )
end

LUI.UICountdown.new = function ( f2_arg0 )
	local self = LUI.UIElement.new()
	if not f2_arg0 then
		f2_arg0 = {}
	end
	if LUI.UIElement.setupUICountdown ~= nil then
		if f2_arg0.endTime == "round_end" then
			self:setupUICountdown()
		else
			self:setupUICountdown( f2_arg0.endTime or 0 )
		end
	end
	self:setClass( LUI.UICountdown )
	return self
end

LUI.UICountdown.freeze = function ( f3_arg0 )
	f3_arg0.m_frozen = true
end

LUI.UICountdown.unfreeze = function ( f4_arg0 )
	f4_arg0.m_frozen = false
end

LUI.UICountdown.setEndTime = function ( f5_arg0, f5_arg1 )
	if LUI.UIElement.setEndTimeInC ~= nil then
		f5_arg0:setEndTimeInC( f5_arg1 )
	end
end

LUI.UICountdown.setTextStyle = function ( f6_arg0, f6_arg1 )
	f6_arg0.m_textStyle = f6_arg1
end

LUI.UICountdown.id = "LUICountdown"
