local f0_local0 = module
local f0_local1, f0_local2 = ...
f0_local0( f0_local1, package.seeall )
CoD.PrintModuleLoad( _NAME )
function squad_pre_party_lobby()
	return {
		type = "UIElement",
		id = "squad_pre_party_lobby",
		states = {
			default = {
				topAnchor = true,
				bottomAnchor = true,
				leftAnchor = true,
				rightAnchor = true,
				top = 0,
				bottom = 0,
				left = 0,
				right = 0
			}
		},
		handlers = {
			menu_create = function ( f2_arg0, f2_arg1 )
				
			end
			,
			menu_close = function ( f3_arg0, f3_arg1 )
				
			end
			
		},
		children = {
			{
				type = "generic_header",
				properties = {
					text = Engine.Localize( "@LUA_MENU_SQUAD_V_SQUAD" )
				}
			},
			{
				type = "UIImage",
				id = "results_bg",
				states = {
					default = {
						material = RegisterMaterial( "white" ),
						left = -320,
						top = -240,
						width = 640,
						height = 480,
						alpha = 0.2
					}
				}
			},
			{
				type = "UIText",
				id = "text1",
				states = {
					default = {
						height = CoD.TextSettings.NormalFont.Height * 1.5,
						font = CoD.TextSettings.NormalFont.Font,
						alignment = LUI.Alignment.Center,
						alpha = 1,
						width = 640,
						top = -100,
						red = 0.9,
						green = 0.9,
						blue = 0
					}
				},
				properties = {
					text = "Host is finding a squad game."
				}
			}
		}
	}
end

LUI.MenuBuilder.registerDef( "squad_pre_party_lobby", squad_pre_party_lobby )
LockTable( _M )
