function ModuleInaccessible( f1_arg0 )
	assert( not _G[f1_arg0] )
	_G[f1_arg0] = setmetatable( {}, {
		__index = function ( f2_arg0, f2_arg1 )
			return function ()
				assert( false, "Functions from the " .. f1_arg0 .. " module are not allowed to be called from this scope." )
			end
			
		end
	} )
end

if Engine then
	Engine.UsingSplitscreenUpscaling = Engine.UsingSplitscreenUpscaling or function ()
		return false
	end
	
	Engine.IsNetworkConnected = Engine.IsNetworkConnected or function ()
		return true
	end
	
	Engine.HasAcceptedInvite = Engine.HasAcceptedInvite or function ()
		return false
	end
	
	Engine.SetAndEnableCustomClanTag = Engine.SetAndEnableCustomClanTag or function ()
		
	end
	
	Engine.CanViewClanTags = Engine.CanViewClanTags or function ()
		return true
	end
	
	Engine.AllowOnline = Engine.AllowOnline or function ()
		return true
	end
	
	Engine.IsSpecialRegion = Engine.IsSpecialRegion or function ()
		return false
	end
	
	Engine.HasSnapshot = Engine.HasSnapshot or function ()
		return true
	end
	
	Engine.APEXTurbulenceAvailable = Engine.APEXTurbulenceAvailable or function ()
		return false
	end
	
	Engine.FurShaderAvailable = Engine.FurShaderAvailable or function ()
		return false
	end
	
	Engine.HBAOAvailable = Engine.HBAOAvailable or function ()
		return false
	end
	
	Engine.NVidiaGPUAvailable = Engine.NVidiaGPUAvailable or function ()
		return false
	end
	
	local f0_local0 = Engine
	local f0_local1 = Engine.TXAAAvailable
	if not f0_local1 then
		f0_local1 = Engine.NVidiaGPUAvailable
	end
	f0_local0.TXAAAvailable = f0_local1
	Engine.CanVidRestart = Engine.CanVidRestart or function ()
		return false
	end
	
	Engine.FormatTimeHoursMinutesSeconds = Engine.FormatTimeHoursMinutesSeconds or function ()
		return ""
	end
	
	Engine.UserIsGuest = Engine.UserIsGuest or function ()
		return false
	end
	
	Engine.ClearCustomClanTag = Engine.ClearCustomClanTag or function ()
		
	end
	
	Engine.GetCurrentDayMonthYear = Engine.GetCurrentDayMonthYear or function ()
		return 1, 1, 2100
	end
	
	Engine.GetCurrentYear = Engine.GetCurrentYear or function ()
		return 2100
	end
	
	Engine.UserCanAccessFriendsList = Engine.UserCanAccessFriendsList or function ()
		return false
	end
	
	Engine.AnyoneHasSeasonPass = Engine.AnyoneHasSeasonPass or function ()
		return false
	end
	
	Engine.AnyoneHasAliensDLC = Engine.AnyoneHasAliensDLC or function ()
		return false
	end
	
	Engine.AnyoneHasAliensDLC1 = Engine.AnyoneHasAliensDLC1 or function ()
		return false
	end
	
	Engine.AnyoneHasAliensDLC2 = Engine.AnyoneHasAliensDLC2 or function ()
		return false
	end
	
	Engine.AnyoneHasAliensDLC3 = Engine.AnyoneHasAliensDLC3 or function ()
		return false
	end
	
	Engine.AnyoneHasAliensDLC4 = Engine.AnyoneHasAliensDLC4 or function ()
		return false
	end
	
	Engine.IsXenonDevTitle = Engine.IsXenonDevTitle or function ()
		return false
	end
	
	Engine.GetRawMonthDayYear = Engine.GetRawMonthDayYear or function ()
		return nil
	end
	
	Engine.GetClanTag = Engine.GetClanTag or function ()
		return ""
	end
	
	Engine.LocalClientProfileCanSave = Engine.LocalClientProfileCanSave or function ()
		return true
	end
	
	Engine.IsProfanity = Engine.IsProfanity or function ()
		return false
	end
	
	Engine.GetAspectRatio = Engine.GetAspectRatio or function ()
		return 1.78
	end
	
	Engine.IsChatRestricted = Engine.IsChatRestricted or function ()
		return false
	end
	
	Engine.UserCanAccessStore = Engine.UserCanAccessStore or function ()
		return false
	end
	
	Engine.ShowXB3GoldUpsell = Engine.ShowXB3GoldUpsell or function ()
		return false
	end
	
	Engine.ShowLowTextureResolutionWarning = Engine.ShowLowTextureResolutionWarning or function ()
		return false
	end
	
	Engine.IsPC = Engine.IsPC or function ()
		return false
	end
	
	Engine.ClearUnlockData = Engine.ClearUnlockData or function ()
		return false
	end
	
	Engine.GetControllerForLocalClient = Engine.GetControllerForLocalClient or function ()
		return 0
	end
	
	Engine.PartyEveryoneHasMap = Engine.PartyEveryoneHasMap or function ()
		return true
	end
	
	Engine.IsActiveLocalClientPrimary = Engine.IsActiveLocalClientPrimary or function ()
		return true
	end
	
	Engine.PLMRefreshData = Engine.PLMRefreshData or function ()
		
	end
	
	Engine.HasSaveDevice = Engine.HasSaveDevice or function ()
		return true
	end
	
	Engine.AnyoneHasSpecificDLCPack = Engine.AnyoneHasSpecificDLCPack or function ()
		return true
	end
	
	Engine.VoteForDLCItem = Engine.VoteForDLCItem or function ()
		
	end
	
	Engine.GetVoteItemText = Engine.GetVoteItemText or function ()
		return ""
	end
	
	Engine.GetVoteItemFileID = Engine.GetVoteItemFileID or function ()
		return -1
	end
	
	Engine.GetActiveVotes = Engine.GetActiveVotes or function ()
		return 0
	end
	
	Engine.GetNumberOfImagesForVote = Engine.GetNumberOfImagesForVote or function ()
		return 0
	end
	
	Engine.StartVoteImageDownload = Engine.StartVoteImageDownload or function ()
		
	end
	
	Engine.IsVoteImageDownloaded = Engine.IsVoteImageDownloaded or function ()
		return false
	end
	
	Engine.GetVoteImageHandle = Engine.GetVoteImageHandle or function ()
		return RegisterMaterial( "white" )
	end
	
	Engine.GetVotingID = Engine.GetVotingID or function ()
		return -1
	end
	
	Engine.GetPlayerDataReservedShort = Engine.GetPlayerDataReservedShort or function ()
		
	end
	
	Engine.SetPlayerDataReservedShort = Engine.SetPlayerDataReservedShort or function ()
		
	end
	
	Engine.GetVotingHeader = Engine.GetVotingHeader or function ()
		return ""
	end
	
	Engine.HasPlayerData = Engine.HasPlayerData or function ()
		return true
	end
	
	Engine.IsAnnouncerReleased = Engine.IsAnnouncerReleased or function ()
		return true
	end
	
	Engine.IsAnnouncerUnlocked = Engine.IsAnnouncerUnlocked or function ()
		return true
	end
	
	Engine.AnyoneHasBadReputation = Engine.AnyoneHasBadReputation or function ()
		return false
	end
	
end
if Game then
	if not Engine.IsConsoleGame() then
		local f0_local0 = Game.GetNumPlayersOnTeam
		Game.GetNumPlayersOnTeam = function ( f63_arg0 )
			if Engine.GetDvarBool( "onlinegame" ) or Engine.GetDvarBool( "systemlink" ) then
				return f0_local0( f63_arg0 )
			else
				return 0
			end
		end
		
	end
	Game.IsKillCamEntityActive = Game.IsKillCamEntityActive or function ()
		return false
	end
	
	Game.IsSpectatorCameraActive = Game.IsSpectatorCameraActive or function ()
		return false
	end
	
	Game.StartBlur = Game.StartBlur or function ()
		
	end
	
	Game.GetLastMLGSpectateTeam = Game.GetLastMLGSpectateTeam or function ()
		return Teams.allies
	end
	
else
	ModuleInaccessible( "Game" )
end
if Store then
	Store.RequestContentServerImages = Store.RequestContentServerImages or function ()
		
	end
	
	Store.GetCategoryForDLCName = Store.GetCategoryForDLCName or function ()
		return 0
	end
	
	Store.ShowSystemOffer = Store.ShowSystemOffer or function ()
		
	end
	
else
	ModuleInaccessible( "Store" )
end
if Friends then
	Friends.HasPartyGameInvite = Friends.HasPartyGameInvite or function ()
		return false
	end
	
	Friends.AcceptLivePartyInvitation = Friends.AcceptLivePartyInvitation or function ()
		
	end
	
	Friends.CanShowFriendGamercard = Friends.CanShowFriendGamercard or function ()
		return true
	end
	
	Friends.GetEliteClanFriendMemberStatus = Friends.GetEliteClanFriendMemberStatus or function ( f74_arg0, f74_arg1 )
		return ""
	end
	
else
	ModuleInaccessible( "Friends" )
end
if Squad then
	Squad.PostMatch = Squad.PostMatch or function ()
		return ""
	end
	
	Squad.GetHostSquadName = Squad.GetHostSquadName or function ()
		return ""
	end
	
	Squad.UpdateReportPlayerCardCache = Squad.UpdateReportPlayerCardCache or function ()
		return ""
	end
	
	Squad.GetReportPlayercard = Squad.GetReportPlayercard or function ()
		
	end
	
	Squad.GetClanTagForReport = Squad.GetClanTagForReport or function ()
		return ""
	end
	
	Squad.GetCompareInfoForLobby = Squad.GetCompareInfoForLobby or function ()
		return {}
	end
	
	Squad.SetMinPlayersToHumanMax = Squad.SetMinPlayersToHumanMax or function ()
		
	end
	
	Squad.GetSquadModePlaylist = Squad.GetSquadModePlaylist or function ( f82_arg0, f82_arg1 )
		if f82_arg1 == 1 then
			return 5, 0
		elseif f82_arg1 == 2 then
			return 5, 4
		elseif f82_arg1 == 3 then
			return 5, 1
		elseif f82_arg1 == 4 then
			return 5, 2
		elseif f82_arg1 == 5 then
			return 5, 3
		elseif f82_arg1 == 6 then
			return 5, 5
		else
			return -1, -1
		end
	end
	
else
	ModuleInaccessible( "Squad" )
end
if Leaderboards then
	Leaderboards.GetPlayerValue = Leaderboards.GetPlayerValue or function ( f83_arg0, f83_arg1 )
		return ""
	end
	
	Leaderboards.GetValue = Leaderboards.GetValue or function ( f84_arg0, f84_arg1, f84_arg2 )
		return ""
	end
	
	Leaderboards.GetOffset = Leaderboards.GetOffset or function ( f85_arg0 )
		return 0
	end
	
	Leaderboards.GetCurrentIndex = Leaderboards.GetCurrentIndex or function ( f86_arg0 )
		return 0
	end
	
	Leaderboards.UpdateLeaderboard = Leaderboards.UpdateLeaderboard or function ( f87_arg0, f87_arg1 )
		
	end
	
	Leaderboards.UpdateCurrentIndex = Leaderboards.UpdateCurrentIndex or function ( f88_arg0, f88_arg1 )
		
	end
	
	Leaderboards.OnSelect = Leaderboards.OnSelect or function ( f89_arg0 )
		
	end
	
else
	ModuleInaccessible( "Leaderboards" )
end
if Lobby then
	Lobby.ShowMemberInfo = Lobby.ShowMemberInfo or function ( f90_arg0, f90_arg1, f90_arg2 )
		return true
	end
	
	Lobby.UnsetAllMLGSpectators = Lobby.UnsetAllMLGSpectators or function ()
		
	end
	
	Lobby.GetMemberWeaponSetup = Lobby.GetMemberWeaponSetup or function ()
		return {}
	end
	
	Lobby.GetPartyPrivacy = Lobby.GetPartyPrivacy or function ()
		return -1
	end
	
	Lobby.SetPartyPrivacy = Lobby.SetPartyPrivacy or function ()
		
	end
	
	Lobby.GetPlayerLimit = Lobby.GetPlayerLimit or function ()
		return -1
	end
	
	Lobby.SetPlayerLimit = Lobby.SetPlayerLimit or function ()
		
	end
	
	Lobby.SetUsingMLGRules = Lobby.SetUsingMLGRules or function ()
		
	end
	
	Lobby.IsUsingMLGRules = Lobby.IsUsingMLGRules or function ()
		return false
	end
	
	Lobby.EnteringLobby = Lobby.EnteringLobby or function ()
		return false
	end
	
	Lobby.EnteredLobby = Lobby.EnteredLobby or function ()
		
	end
	
	Lobby.HowManyPlayersCanWeHost = Lobby.HowManyPlayersCanWeHost or function ()
		return 12
	end
	
	Lobby.IsUsingSecondScreen = Lobby.IsUsingSecondScreen or function ()
		return false
	end
	
	Lobby.IsAlone = Lobby.IsAlone or function ()
		return false
	end
	
	Lobby.IsChaosEnabled = Lobby.IsChaosEnabled or function ()
		return false
	end
	
	Lobby.SetChaosEnabled = Lobby.SetChaosEnabled or function ()
		
	end
	
	Lobby.SetExtinctionDifficulty = Lobby.SetExtinctionDifficulty or function ()
		
	end
	
	Lobby.GetExtinctionDifficulty = Lobby.GetExtinctionDifficulty or function ()
		return 2
	end
	
else
	ModuleInaccessible( "Lobby" )
end
if LobbyMember then
	LobbyMember.SelectedMember_SetLocalMemberMLGSpectator = LobbyMember.SelectedMember_SetLocalMemberMLGSpectator or function ()
		
	end
	
end
Clan = Clan or {}
Clan.IsEnabled = Clan.IsEnabled or function ()
	return false
end

Clan.IsDownloadingData = Clan.IsDownloadingData or function ()
	return false
end

Clan.GetDCXPTime = Clan.GetDCXPTime or function ()
	return 0
end

Clan.GetClanDivision = Clan.GetClanDivision or function ()
	return 0
end

CoDAnywhere = CoDAnywhere or {}
CoDAnywhere.HasUCDSaveGame = CoDAnywhere.HasUCDSaveGame or function ()
	return false
end

CoDAnywhere.ServiceAvailable = CoDAnywhere.ServiceAvailable or function ()
	return true
end

if Playlist then
	Playlist.GetCanShowItem = Playlist.GetCanShowItem or function ()
		return true
	end
	
	Playlist.GetItemMaxParty = Playlist.GetItemMaxParty or function ()
		return 12
	end
	
	Playlist.WillCXPBeAwarded = Playlist.WillCXPBeAwarded or function ()
		return false
	end
	
	Playlist.GetItemVideo = Playlist.GetItemVideo or function ()
		return ""
	end
	
else
	ModuleInaccessible( "Playlist" )
end
if CharacterScene then
	
else
	ModuleInaccessible( "CharacterScene" )
end
MLG = MLG or {}
MLG.GetFollowedClientNum = MLG.GetFollowedClientNum or function ()
	
end

MLG.HighlightClientNum = MLG.HighlightClientNum or function ()
	
end

MLG.TogglePlayerOutlines = MLG.TogglePlayerOutlines or function ()
	
end

Customization = Customization or {}
Customization.GetCompleteHeadModelName = Customization.GetCompleteHeadModelName or function ( f122_arg0, f122_arg1 )
	local f122_local0 = Engine.TableLookup( "mp/cac/heads.csv", 0, f122_arg0, 1 )
	local f122_local1 = ""
	if f122_arg1 then
		f122_local1 = Engine.TableLookup( "mp/cac/helmets.csv", 0, f122_arg1, 1 )
	end
	return f122_local0 .. f122_local1
end

MatchRules = MatchRules or {}
MatchRules.SelectSaveDevice = MatchRules.SelectSaveDevice or function ()
	
end

MatchRules.HasSelectedSaveDevice = MatchRules.HasSaveDevice or function ()
	return true
end

SocialFeed = SocialFeed or {}
SocialFeed.GetNewsItemID = SocialFeed.GetNewsItemID or function ()
	return ""
end

SocialFeed.HasIOTD = SocialFeed.HasIOTD or function ()
	return true
end

SocialFeed.DowloadIOTD = SocialFeed.DowloadIOTD or function ()
	
end

SocialFeed.SetNewsArticleImageJPEG = SocialFeed.SetNewsArticleImageJPEG or function ()
	
end

