LUI.UIText = InheritFrom( LUI.UIElement )
LUI.UIText.build = function ( f1_arg0, f1_arg1 )
	return LUI.UIText.new()
end

LUI.UIText.new = function ( f2_arg0 )
	local self = LUI.UIElement.new( f2_arg0 )
	self:setClass( LUI.UIText )
	self:setupUIText()
	return self
end

LUI.UIText.TransitionComplete_OutState = function ( f3_arg0, f3_arg1 )
	f3_arg0:setText( f3_arg0.replaceContentData.text )
	f3_arg0:registerEventHandler( "transition_complete_" .. f3_arg0.replaceContentData.outState, nil )
	f3_arg0:animateToState( f3_arg0.replaceContentData.inState, f3_arg0.replaceContentData.inDuration )
	f3_arg0.replaceContentData = nil
end

LUI.UIText.setText = function ( f4_arg0, f4_arg1, f4_arg2, f4_arg3, f4_arg4, f4_arg5 )
	if f4_arg2 ~= nil and f4_arg3 ~= nil then
		f4_arg0.replaceContentData = {}
		f4_arg0.replaceContentData.outState = f4_arg2
		f4_arg0.replaceContentData.inState = f4_arg3
		f4_arg0.replaceContentData.outDuration = f4_arg4
		f4_arg0.replaceContentData.inDuration = f4_arg5
		f4_arg0.replaceContentData.text = f4_arg1
		f4_arg0:registerEventHandler( "transition_complete_" .. f4_arg2, LUI.UIText.TransitionComplete_OutState )
		f4_arg0:animateToState( f4_arg2, f4_arg4 )
		return 
	else
		f4_arg0:setTextInC( f4_arg1 )
	end
end

LUI.UIText.setTextStyle = function ( f5_arg0, f5_arg1 )
	f5_arg0.m_textStyle = f5_arg1
end

LUI.UIText.setForceLineBreaks = function ( f6_arg0, f6_arg1 )
	f6_arg0.m_forceLineBreaks = f6_arg1
end

LUI.UIText.id = "LUIText"
