local f0_local0 = module
local f0_local1, f0_local2 = ...
f0_local0( f0_local1, package.seeall )
CoD.PrintModuleLoad( _NAME )
f0_local0 = function ( f1_arg0, f1_arg1 )
	if f1_arg1.value == 1 then
		local f1_local0 = f1_arg0:getChildById( "vanguardWarning" )
		f1_local0:animateToState( "default", 0 )
		f1_local0.isBlinking = nil
		f1_arg0:animateToState( "active", 100 )
		local f1_local1 = f1_arg0:getChildById( "vanguardReticleImageId" )
		f1_local1:animateToState( "active", 100 )
		local f1_local2 = f1_arg0:getChildById( "vanguardStaticId" )
		f1_local2:animateToState( "default", 100 )
		local f1_local3 = f1_arg0:getChildById( "bar1" )
		if not f1_local3.spinning then
			local f1_local4 = MBh.AnimateLoop( {
				{
					"blink_on",
					1000
				},
				{
					"blink_off",
					500
				},
				{
					"blink_off",
					500
				}
			} )
			f1_local4( f1_local3 )
			f1_local3.spinning = true
		end
	elseif f1_arg1.value >= 2 then
		local f1_local0 = f1_arg0:getChildById( "vanguardStaticId" )
		local f1_local1 = f1_arg0:getChildById( "vanguardReticleImageId" )
		local f1_local2 = f1_arg0:getChildById( "vanguardWarning" )
		if f1_arg1.value >= 10 then
			f1_local0:animateToState( "active10", 200 )
			f1_local1:animateToState( "default", 0 )
		elseif f1_arg1.value >= 9 then
			f1_local0:animateToState( "active9", 200 )
			f1_local1:animateToState( "default", 0 )
		elseif f1_arg1.value >= 8 then
			f1_local0:animateToState( "active8", 200 )
			f1_local1:animateToState( "default", 0 )
		elseif f1_arg1.value >= 7 then
			f1_local0:animateToState( "active7", 200 )
			f1_local1:animateToState( "default", 0 )
		elseif f1_arg1.value >= 6 then
			f1_local0:animateToState( "active6", 200 )
			f1_local1:animateToState( "active", 0 )
		elseif f1_arg1.value >= 5 then
			f1_local0:animateToState( "active5", 200 )
			f1_local1:animateToState( "active", 0 )
		elseif f1_arg1.value >= 4 then
			f1_local0:animateToState( "active4", 200 )
			f1_local1:animateToState( "active", 0 )
		elseif f1_arg1.value >= 3 then
			f1_local0:animateToState( "active3", 200 )
			f1_local1:animateToState( "active", 0 )
		else
			f1_local0:animateToState( "active2", 200 )
			f1_local1:animateToState( "active", 0 )
			if not f1_local2.isBlinking then
				f1_local2.isBlinking = true
				local f1_local3 = MBh.AnimateLoop( {
					{
						"showing",
						500
					},
					{
						"blink",
						500
					}
				} )
				f1_local3( f1_local2 )
			end
		end
	else
		f1_arg0:animateToState( "default", 0 )
		local f1_local0 = f1_arg0:getChildById( "vanguardStaticId" )
		f1_local0:animateToState( "default", 0 )
	end
end

f0_local1 = function ( f2_arg0, f2_arg1 )
	local f2_local0 = f2_arg0:getChildById( "vanguardHeadingId" )
	f2_local0:setText( Engine.Localize( "@MP_ALIEN_DESCENT_VANGUARD_HEADING_LABEL", Game.GetOmnvar( "ui_vanguard_heading" ) ) )
	local f2_local1 = f2_arg0:getChildById( "vanguardAltitudeId" )
	f2_local1:setText( Engine.Localize( "@MP_ALIEN_DESCENT_VANGUARD_ALT_LABEL", Game.GetOmnvar( "ui_vanguard_altitude" ) ) )
	local f2_local2 = f2_arg0:getChildById( "vanguardRangeId" )
	f2_local2:setText( Engine.Localize( "@MP_ALIEN_DESCENT_VANGUARD_RANGE", Game.GetOmnvar( "ui_vanguard_range" ) ) )
end

f0_local2 = function ( f3_arg0, f3_arg1 )
	local f3_local0 = f3_arg0:getChildById( "vanguardWeaponId" )
	local f3_local1 = "@MP_ALIEN_DESCENT_VANGUARD_WEAPON_STATUS_READY"
	if f3_arg1.value < 0 then
		f3_local1 = "@MP_ALIEN_DESCENT_VANGUARD_WEAPON_STATUS_RELOAD"
		local f3_local2 = f3_arg0:getChildById( "vanguardOverlayImageId" )
		local f3_local3 = MBh.AnimateSequence( {
			{
				"default",
				0
			},
			{
				"active",
				100
			},
			{
				"default",
				500
			}
		} )
		f3_local3( f3_local2 )
		f3_local0:animateToState( "reload", 0 )
	else
		f3_local0:animateToState( "default", 0 )
	end
	f3_local0:setText( Engine.Localize( "@MP_ALIEN_DESCENT_VANGUARD_WEAPON_STATUS_LABEL", Engine.Localize( f3_local1 ) ) )
end

local f0_local3 = function ( f4_arg0, f4_arg1 )
	local f4_local0 = f4_arg0:getChildById( "vanguardHealthId" )
	f4_local0:setText( Engine.Localize( "@MP_ALIEN_DESCENT_VANGUARD_HEALTH", f4_arg1.value ) )
	if f4_arg1.value < 25 then
		f4_local0:animateToState( "near_death", 0 )
	elseif f4_arg1.value < 50 then
		f4_local0:animateToState( "damaged", 0 )
	else
		f4_local0:animateToState( "default", 0 )
	end
end

local f0_local4 = function ( f5_arg0, f5_arg1 )
	local f5_local0 = f5_arg0:getChildById( "vanguardControlsVLId" )
	local f5_local1 = f5_local0:getChildById( "steeringTextId" )
	local f5_local2 = f5_local0:getChildById( "steeringText2Id" )
	local f5_local3 = f5_local0:getChildById( "fireTextId" )
	if CoD.UsingController() then
		f5_local1:setText( Engine.Localize( "@MP_ALIEN_DESCENT_REMOTE_UAV_ASCEND" ) )
		f5_local2:setText( Engine.Localize( "@MP_ALIEN_DESCENT_REMOTE_UAV_DESCEND" ) )
	else
		f5_local1:setText( Engine.Localize( "@PLATFORM_REMOTE_UAV_ASCEND" ) )
		f5_local2:setText( Engine.Localize( "@PLATFORM_REMOTE_UAV_DESCEND" ) )
	end
	f5_local3:setText( Engine.Localize( "@PLATFORM_PREDATOR_MISSILE_FIRE" ) )
end

function alienVanguardOverlayDef()
	local f6_local0 = RegisterMaterial( "ac130_overlay_grain" )
	local f6_local1 = RegisterMaterial( "gryphon_hud_mp_alien" )
	local f6_local2 = RegisterMaterial( "white" )
	local f6_local3, f6_local4 = GameX.GetScreenDims()
	local f6_local5, f6_local6 = nil
	local self = LUI.UIElement.new()
	self.id = "vanguardOverlayContainerId"
	self:registerAnimationState( "default", {
		topAnchor = true,
		bottomAnchor = true,
		leftAnchor = true,
		rightAnchor = true,
		top = 0,
		left = 0,
		right = 0,
		bottom = 0
	} )
	self:animateToState( "default" )
	local f6_local8 = LUI.UIElement.new()
	f6_local8.id = "vanguardOverlayMainElemId"
	f6_local8:registerAnimationState( "default", {
		topAnchor = true,
		leftAnchor = true,
		bottomAnchor = true,
		rightAnchor = true,
		top = 0,
		left = 0,
		bottom = 0,
		right = 0,
		alpha = 0
	} )
	f6_local8:animateToState( "default", 0 )
	f6_local8:registerAnimationState( "active", {
		alpha = 1
	} )
	f6_local8:registerOmnvarHandler( "ui_vanguard", f0_local0 )
	f6_local8:registerEventHandler( "init_overlay", f0_local0 )
	f6_local8:registerEventHandler( "refresh_controls", f0_local4 )
	f6_local8:registerOmnvarHandler( "ui_vanguard_heading", f0_local1 )
	f6_local8:registerOmnvarHandler( "ui_vanguard_ammo", f0_local2 )
	f6_local8:registerOmnvarHandler( "ui_vanguard_health", f0_local3 )
	local f6_local9 = LUI.UIImage.new()
	f6_local9.id = "vanguardOverlayImageId"
	f6_local9:registerAnimationState( "default", {
		topAnchor = true,
		leftAnchor = true,
		bottomAnchor = true,
		rightAnchor = true,
		top = 0,
		left = 0,
		bottom = 0,
		right = 0,
		material = f6_local0,
		red = 0.9,
		green = 1,
		blue = 1,
		alpha = 0.45
	} )
	f6_local9:animateToState( "default", 0 )
	f6_local9:registerAnimationState( "active", {
		alpha = 1
	} )
	f6_local8:addElement( f6_local9 )
	local f6_local10 = LUI.UIImage.new()
	f6_local10.id = "vanguardReticleImageId"
	f6_local10:registerAnimationState( "default", {
		topAnchor = true,
		leftAnchor = true,
		bottomAnchor = true,
		rightAnchor = true,
		material = f6_local1,
		alpha = 0
	} )
	f6_local10:animateToState( "default", 0 )
	f6_local10:registerAnimationState( "active", {
		topAnchor = true,
		leftAnchor = true,
		bottomAnchor = true,
		rightAnchor = true,
		material = f6_local1,
		alpha = 1
	} )
	f6_local8:addElement( f6_local10 )
	local f6_local11 = LUI.UIText.new()
	f6_local11.id = "vanguardWarning"
	f6_local11:setText( Engine.Localize( "@MP_ALIEN_DESCENT_REMOTE_UAV_OUT_OF_RANGE" ) )
	f6_local11:setTextStyle( CoD.TextStyle.None )
	f6_local11:registerAnimationState( "default", {
		topAnchor = true,
		leftAnchor = true,
		bottomAnchor = false,
		rightAnchor = true,
		top = 256,
		height = CoD.TextSettings.HudEuroBigFont.Height,
		font = CoD.TextSettings.HudEuroBigFont.Font,
		alignment = LUI.Alignment.Center,
		red = Colors.red.r,
		green = Colors.red.g,
		blue = Colors.red.b,
		alpha = 0
	} )
	f6_local11:animateToState( "default", 0 )
	f6_local11:registerAnimationState( "showing", {
		red = Colors.red.r,
		alpha = 1
	} )
	f6_local11:registerAnimationState( "blink", {
		red = 0.5,
		alpha = 0.5
	} )
	if not MLG.IsMLGSpectator() then
		f6_local6 = LUI.UIHorizontalList.new()
		f6_local6.id = "vanguardControlsVLId"
		f6_local6:registerAnimationState( "default", {
			topAnchor = false,
			leftAnchor = false,
			bottomAnchor = true,
			rightAnchor = false,
			bottom = -66,
			left = -384,
			right = 384,
			height = 64,
			alpha = 1,
			spacing = 0
		} )
		f6_local6:animateToState( "default", 0 )
		local f6_local12 = LUI.UIText.new()
		f6_local12.id = "steeringTextId"
		local f6_local13 = nil
		if CoD.UsingController() then
			f6_local13 = "@MP_ALIEN_DESCENT_REMOTE_UAV_ASCEND"
		else
			f6_local13 = "@PLATFORM_REMOTE_UAV_ASCEND"
		end
		f6_local12:setText( Engine.Localize( f6_local13 ) )
		f6_local12:setTextStyle( CoD.TextStyle.Shadowed )
		f6_local12:registerAnimationState( "default", {
			topAnchor = false,
			leftAnchor = false,
			bottomAnchor = true,
			rightAnchor = false,
			bottom = 0,
			width = 192,
			height = CoD.TextSettings.HudEuroNormalFont.Height,
			font = CoD.TextSettings.HudEuroNormalFont.Font,
			alignment = LUI.Alignment.Center
		} )
		f6_local12:animateToState( "default", 0 )
		local f6_local14 = LUI.UIText.new()
		f6_local14.id = "steeringText2Id"
		if CoD.UsingController() then
			f6_local13 = "@MP_ALIEN_DESCENT_REMOTE_UAV_DESCEND"
		else
			f6_local13 = "@PLATFORM_REMOTE_UAV_DESCEND"
		end
		f6_local14:setText( Engine.Localize( f6_local13 ) )
		f6_local14:setTextStyle( CoD.TextStyle.Shadowed )
		f6_local14:registerAnimationState( "default", {
			topAnchor = false,
			leftAnchor = false,
			bottomAnchor = true,
			rightAnchor = false,
			bottom = 0,
			width = 192,
			height = CoD.TextSettings.HudEuroNormalFont.Height,
			font = CoD.TextSettings.HudEuroNormalFont.Font,
			alignment = LUI.Alignment.Center
		} )
		f6_local14:animateToState( "default", 0 )
		local f6_local15 = LUI.UIText.new()
		f6_local15.id = "fireTextId"
		if Engine.IsConsoleGame() then
			f6_local15:setText( Engine.Localize( "@MP_ALIEN_DESCENT_VANGUARD_ALT_FIRE" ) )
		else
			f6_local15:setText( Engine.Localize( "@MP_ALIEN_DESCENT_VANGUARD_ALT_FIRE_PC" ) )
		end
		f6_local15:setTextStyle( CoD.TextStyle.Shadowed )
		f6_local15:registerAnimationState( "default", {
			topAnchor = false,
			leftAnchor = false,
			bottomAnchor = true,
			rightAnchor = false,
			bottom = 0,
			width = 192,
			height = CoD.TextSettings.HudEuroNormalFont.Height,
			font = CoD.TextSettings.HudEuroNormalFont.Font,
			alignment = LUI.Alignment.Center
		} )
		f6_local15:animateToState( "default", 0 )
		local f6_local16 = LUI.UIText.new()
		f6_local16.id = "missileTextId"
		f6_local16:setText( Engine.Localize( "@MP_ALIEN_DESCENT_VANGUARD_LAUNCH_MISSILE" ) )
		f6_local16:setTextStyle( CoD.TextStyle.Shadowed )
		f6_local16:registerAnimationState( "default", {
			topAnchor = false,
			leftAnchor = false,
			bottomAnchor = true,
			rightAnchor = false,
			bottom = 0,
			width = 192,
			height = CoD.TextSettings.HudEuroNormalFont.Height,
			font = CoD.TextSettings.HudEuroNormalFont.Font,
			alignment = LUI.Alignment.Center
		} )
		f6_local16:animateToState( "default", 0 )
		f6_local6:addElement( f6_local14 )
		f6_local6:addElement( f6_local15 )
		f6_local6:addElement( f6_local16 )
		f6_local6:addElement( f6_local12 )
	end
	if not MLG.IsMLGSpectator() then
		f6_local5 = LUI.UIText.new()
		f6_local5.id = "vanguardTitleId"
		f6_local5:setText( Engine.Localize( "@MP_ALIEN_DESCENT_VANGUARD_TITLE" ) )
		f6_local5:setTextStyle( CoD.TextStyle.None )
		f6_local5:registerAnimationState( "default", {
			topAnchor = true,
			leftAnchor = true,
			bottomAnchor = false,
			rightAnchor = false,
			top = 72,
			left = 130,
			height = CoD.TextSettings.HudEuroConRegSmallFont.Height,
			font = CoD.TextSettings.HudEuroConRegSmallFont.Font,
			alignment = LUI.Alignment.Left
		} )
		f6_local5:animateToState( "default", 0 )
		f6_local8:addElement( f6_local5 )
	end
	local f6_local12 = RegisterMaterial( "apache_ammo_mp" )
	local f6_local13 = LUI.UIImage.new()
	f6_local13.id = "bar1"
	f6_local13:registerAnimationState( "default", {
		topAnchor = true,
		leftAnchor = true,
		bottomAnchor = false,
		rightAnchor = false,
		top = 72,
		right = 128,
		height = 16,
		width = 16,
		material = f6_local12,
		alpha = 1,
		zRot = 90
	} )
	f6_local13:animateToState( "default", 0 )
	f6_local13:registerAnimationState( "blink_on", {
		red = Colors.white.r,
		green = Colors.white.g,
		blue = Colors.white.b,
		alpha = 1
	} )
	f6_local13:registerAnimationState( "blink_off", {
		red = Colors.grey_2.r,
		green = Colors.grey_2.g,
		blue = Colors.grey_2.b,
		alpha = 0.25
	} )
	f6_local8:addElement( f6_local13 )
	f6_local5 = LUI.UIText.new()
	f6_local5.id = "vanguardFlightModeId"
	f6_local5:setText( Engine.Localize( "@MP_ALIEN_DESCENT_VANGUARD_FLIGHT_MODE" ) )
	f6_local5:setTextStyle( CoD.TextStyle.None )
	f6_local5:registerAnimationState( "default", {
		topAnchor = false,
		leftAnchor = true,
		bottomAnchor = true,
		rightAnchor = false,
		bottom = -144,
		left = 160,
		height = CoD.TextSettings.HudEuroConRegSmallFont.Height,
		font = CoD.TextSettings.HudEuroConRegSmallFont.Font,
		alignment = LUI.Alignment.Left
	} )
	f6_local5:animateToState( "default", 0 )
	f6_local8:addElement( f6_local5 )
	f6_local5 = LUI.UIText.new()
	f6_local5.id = "vanguardHeadingId"
	f6_local5:setText( Engine.Localize( "@MP_ALIEN_DESCENT_VANGUARD_HEADING_LABEL" ) )
	f6_local5:setTextStyle( CoD.TextStyle.None )
	f6_local5:registerAnimationState( "default", {
		topAnchor = false,
		leftAnchor = true,
		bottomAnchor = true,
		rightAnchor = false,
		bottom = -122,
		left = 160,
		height = CoD.TextSettings.HudEuroConRegSmallFont.Height,
		font = CoD.TextSettings.HudEuroConRegSmallFont.Font,
		alignment = LUI.Alignment.Left
	} )
	f6_local5:animateToState( "default", 0 )
	f6_local8:addElement( f6_local5 )
	f6_local5 = LUI.UIText.new()
	f6_local5.id = "vanguardAltitudeId"
	f6_local5:setText( Engine.Localize( "@MP_ALIEN_DESCENT_VANGUARD_ALT_LABEL" ) )
	f6_local5:setTextStyle( CoD.TextStyle.None )
	f6_local5:registerAnimationState( "default", {
		topAnchor = false,
		leftAnchor = true,
		bottomAnchor = true,
		rightAnchor = false,
		bottom = -100,
		left = 160,
		height = CoD.TextSettings.HudEuroConRegSmallFont.Height,
		font = CoD.TextSettings.HudEuroConRegSmallFont.Font,
		alignment = LUI.Alignment.Left
	} )
	f6_local5:animateToState( "default", 0 )
	f6_local8:addElement( f6_local5 )
	f6_local5 = LUI.UIText.new()
	f6_local5.id = "vanguardWeaponId"
	f6_local5:setText( Engine.Localize( "@MP_ALIEN_DESCENT_VANGUARD_WEAPON_STATUS_LABEL", Engine.Localize( "@MP_ALIEN_DESCENT_VANGUARD_WEAPON_STATUS_READY" ) ) )
	f6_local5:setTextStyle( CoD.TextStyle.None )
	f6_local5:registerAnimationState( "default", {
		topAnchor = false,
		leftAnchor = false,
		bottomAnchor = true,
		rightAnchor = true,
		bottom = -144,
		right = -165,
		height = CoD.TextSettings.HudEuroConRegSmallFont.Height,
		font = CoD.TextSettings.HudEuroConRegSmallFont.Font,
		alignment = LUI.Alignment.Right,
		red = 0,
		green = 1,
		blue = 0,
		alpha = 1
	} )
	f6_local5:animateToState( "default", 0 )
	f6_local5:registerAnimationState( "reload", {
		red = 1,
		green = 0,
		blue = 0
	} )
	f6_local8:addElement( f6_local5 )
	f6_local5 = LUI.UIText.new()
	f6_local5.id = "vanguardRangeId"
	f6_local5:setText( Engine.Localize( "@MP_ALIEN_DESCENT_VANGUARD_RANGE", 0 ) )
	f6_local5:setTextStyle( CoD.TextStyle.None )
	f6_local5:registerAnimationState( "default", {
		topAnchor = false,
		leftAnchor = false,
		bottomAnchor = true,
		rightAnchor = true,
		bottom = -122,
		right = -165,
		height = CoD.TextSettings.HudEuroConRegSmallFont.Height,
		font = CoD.TextSettings.HudEuroConRegSmallFont.Font,
		alignment = LUI.Alignment.Right,
		red = Colors.white.r,
		green = Colors.white.g,
		blue = Colors.white.b,
		alpha = 1
	} )
	f6_local5:animateToState( "default", 0 )
	f6_local8:addElement( f6_local5 )
	f6_local5 = LUI.UIText.new()
	f6_local5.id = "vanguardHealthId"
	f6_local5:setText( Engine.Localize( "@MP_ALIEN_DESCENT_VANGUARD_HEALTH", 100 ) )
	f6_local5:setTextStyle( CoD.TextStyle.None )
	f6_local5:registerAnimationState( "default", {
		topAnchor = false,
		leftAnchor = false,
		bottomAnchor = true,
		rightAnchor = true,
		bottom = -100,
		right = -165,
		height = CoD.TextSettings.HudEuroConRegSmallFont.Height,
		font = CoD.TextSettings.HudEuroConRegSmallFont.Font,
		alignment = LUI.Alignment.Right,
		red = 0,
		green = 1,
		blue = 0,
		alpha = 1
	} )
	f6_local5:animateToState( "default", 0 )
	f6_local5:registerAnimationState( "damaged", {
		red = 1,
		green = 1,
		blue = 0
	} )
	f6_local5:registerAnimationState( "near_death", {
		red = 1,
		green = 0,
		blue = 0
	} )
	f6_local8:addElement( f6_local5 )
	local f6_local14 = LUI.UIElement.new()
	f6_local14.id = "vanguardStaticId"
	f6_local14:registerAnimationState( "default", {
		topAnchor = true,
		leftAnchor = true,
		bottomAnchor = true,
		rightAnchor = true,
		top = 0,
		left = 0,
		bottom = 0,
		right = 0,
		alpha = 0
	} )
	f6_local14:animateToState( "default", 0 )
	f6_local14:registerAnimationState( "active", {
		alpha = 0.1
	} )
	f6_local14:registerAnimationState( "active2", {
		alpha = 0.2
	} )
	f6_local14:registerAnimationState( "active3", {
		alpha = 0.3
	} )
	f6_local14:registerAnimationState( "active4", {
		alpha = 0.4
	} )
	f6_local14:registerAnimationState( "active5", {
		alpha = 0.5
	} )
	f6_local14:registerAnimationState( "active6", {
		alpha = 0.6
	} )
	f6_local14:registerAnimationState( "active7", {
		alpha = 0.7
	} )
	f6_local14:registerAnimationState( "active8", {
		alpha = 0.8
	} )
	f6_local14:registerAnimationState( "active9", {
		alpha = 0.9
	} )
	f6_local14:registerAnimationState( "active10", {
		alpha = 1
	} )
	local f6_local15 = LUI.UIImage.new()
	f6_local15.id = "vanguardWhiteImageId"
	f6_local15:registerAnimationState( "default", {
		topAnchor = true,
		leftAnchor = true,
		bottomAnchor = true,
		rightAnchor = true,
		top = 0,
		left = 0,
		bottom = 0,
		right = 0,
		material = f6_local2
	} )
	f6_local15:animateToState( "default", 0 )
	local f6_local16 = LUI.UIImage.new()
	f6_local16.id = "vanguardStaticImageId"
	f6_local16:registerAnimationState( "default", {
		topAnchor = true,
		leftAnchor = true,
		bottomAnchor = true,
		rightAnchor = true,
		top = 0,
		left = 0,
		bottom = 0,
		right = 0,
		material = f6_local0
	} )
	f6_local16:animateToState( "default", 0 )
	f6_local14:addElement( f6_local15 )
	f6_local14:addElement( f6_local16 )
	if not MLG.IsMLGSpectator() then
		f6_local8:addElement( f6_local6 )
	end
	f6_local8:addElement( f6_local14 )
	f6_local8:addElement( f6_local11 )
	self:addElement( f6_local8 )
	return self
end

LUI.MenuBuilder.registerType( "alienVanguardOverlayDef", alienVanguardOverlayDef )
LockTable( _M )
