local f0_local0 = module
local f0_local1, f0_local2 = ...
f0_local0( f0_local1, package.seeall )
CoD.PrintModuleLoad( _NAME )
f0_local0 = 0
f0_local1 = 0
f0_local2 = 0
local f0_local3 = 1
local f0_local4 = 30
local f0_local5 = f0_local4 / 2
local f0_local6 = 40 / 2
local f0_local7 = 0
local f0_local8 = 80
local f0_local9 = 60
local f0_local10 = f0_local9 / 2
local f0_local11 = 160
local f0_local12 = function ( f1_arg0, f1_arg1, f1_arg2 )
	local f1_local0 = f1_arg0:getChildById( "fire_team_bg_" .. f1_arg1 )
	if f1_local0 ~= nil then
		if f1_arg2 ~= nil then
			f1_local0.properties.toggle_state = f1_arg2
		elseif f1_local0.properties.toggle_state == 1 then
			f1_local0.properties.toggle_state = 0
		else
			f1_local0.properties.toggle_state = 1
		end
		if f1_local0.properties.toggle_state == 1 then
			f1_local0:animateToState( "active", 0 )
		else
			f1_local0:animateToState( "default", 0 )
		end
	end
end

local f0_local13 = function ( f2_arg0, f2_arg1, f2_arg2, f2_arg3 )
	return {
		type = "UIImage",
		id = "fire_team_bg_" .. f2_arg0,
		states = {
			default = {
				topAnchor = false,
				leftAnchor = false,
				bottomAnchor = false,
				rightAnchor = false,
				top = f2_arg3 - f0_local10,
				left = f2_arg2 - f0_local10,
				width = f0_local9,
				height = f0_local9,
				material = RegisterMaterial( "waypoint_captureneutral_" .. f2_arg1 ),
				alpha = 1
			},
			active = MBh.BaseState( "default", {
				material = RegisterMaterial( "waypoint_capture_" .. f2_arg1 )
			} )
		},
		properties = {
			toggle_state = 0
		}
	}
end

local f0_local14 = function ( f3_arg0, f3_arg1, f3_arg2, f3_arg3 )
	return {
		type = "UIText",
		id = "fire_team_image_" .. f3_arg0,
		properties = {
			text = Engine.Localize( f3_arg1 )
		},
		states = {
			default = {
				topAnchor = false,
				leftAnchor = false,
				bottomAnchor = false,
				rightAnchor = false,
				top = f3_arg3 - f0_local5,
				left = f3_arg2 - f0_local5,
				width = f0_local4,
				height = f0_local4,
				font = CoD.TextSettings.HudEuroMedSmallFont.Font,
				alignment = LUI.Alignment.Center,
				alpha = 1
			}
		}
	}
end

local f0_local15 = function ( f4_arg0, f4_arg1, f4_arg2, f4_arg3, f4_arg4 )
	return {
		type = "UIText",
		id = "fire_team_bg_" .. f4_arg0,
		properties = {
			text = Engine.Localize( f4_arg1 ),
			toggle_state = 0
		},
		states = {
			default = {
				topAnchor = false,
				leftAnchor = false,
				bottomAnchor = false,
				rightAnchor = false,
				top = f4_arg3 - 8,
				left = f4_arg2,
				width = 1,
				height = 16,
				font = CoD.TextSettings.HudEuroMedSmallFont.Font,
				alignment = f4_arg4,
				red = 1,
				green = 1,
				blue = 1,
				alpha = 1
			},
			active = MBh.BaseState( "default", {
				red = 0.88,
				green = 0.65,
				blue = 0.17
			} )
		}
	}
end

local f0_local16 = function ( f5_arg0, f5_arg1 )
	Engine.NotifyServer( "tactics_menu", 1 )
	f0_local12( f5_arg0, "a", f0_local0 )
	f0_local12( f5_arg0, "b", f0_local1 )
	f0_local12( f5_arg0, "x", f0_local2 )
	f0_local12( f5_arg0, "y", f0_local3 )
	f5_arg0:processEvent( {
		name = "mp_fire_team_on"
	} )
end

local f0_local17 = function ( f6_arg0, f6_arg1 )
	local f6_local0 = f6_arg0:getChildById( "fire_team_bg_a" )
	local f6_local1 = f6_arg0:getChildById( "fire_team_bg_b" )
	local f6_local2 = f6_arg0:getChildById( "fire_team_bg_x" )
	local f6_local3 = f6_arg0:getChildById( "fire_team_bg_y" )
	f0_local0 = f6_local0.properties.toggle_state
	f0_local1 = f6_local1.properties.toggle_state
	f0_local2 = f6_local2.properties.toggle_state
	f0_local3 = f6_local3.properties.toggle_state
end

local f0_local18 = function ( f7_arg0 )
	local f7_local0 = f7_arg0:getChildById( "fire_team_bg_a" )
	local f7_local1 = f7_arg0:getChildById( "fire_team_bg_b" )
	local f7_local2 = f7_arg0:getChildById( "fire_team_bg_x" )
	if f7_local0.properties.toggle_state == 0 and f7_local1.properties.toggle_state == 0 and f7_local2.properties.toggle_state == 0 then
		f0_local12( f7_arg0, "y", 1 )
	else
		f0_local12( f7_arg0, "y", 0 )
	end
end

local f0_local19 = function ( f8_arg0, f8_arg1 )
	local f8_local0 = f8_arg0:getChildById( "fire_team_bg_a" )
	local f8_local1 = f8_arg0:getChildById( "fire_team_bg_b" )
	local f8_local2 = f8_arg0:getChildById( "fire_team_bg_x" )
	local f8_local3 = ""
	if f8_local0.properties.toggle_state == 1 then
		f8_local3 = f8_local3 .. "a"
	end
	if f8_local1.properties.toggle_state == 1 then
		f8_local3 = f8_local3 .. "b"
	end
	if f8_local2.properties.toggle_state == 1 then
		f8_local3 = f8_local3 .. "c"
	end
	local f8_local4 = {
		 = 1,
		a = 2,
		b = 3,
		c = 4,
		ab = 5,
		ac = 6,
		bc = 7,
		abc = 8
	}
	local f8_local5 = {
		 = "@MPUI_FT_TACTIC_NONE",
		a = Engine.Localize( "@MPUI_FT_HOLD_1", "A" ),
		b = Engine.Localize( "@MPUI_FT_HOLD_1", "B" ),
		c = Engine.Localize( "@MPUI_FT_HOLD_1", "C" ),
		ab = Engine.Localize( "@MPUI_FT_HOLD_2", "A", "B" ),
		ac = Engine.Localize( "@MPUI_FT_HOLD_2", "A", "C" ),
		bc = Engine.Localize( "@MPUI_FT_HOLD_2", "B", "C" ),
		abc = Engine.Localize( "@MPUI_FT_HOLD_3" )
	}
	FireTeam.tactic_name = f8_local5[f8_local3]
	Engine.NotifyServer( "tactic_select", f8_local4[f8_local3] )
end

local f0_local20 = function ( f9_arg0, f9_arg1 )
	if f9_arg1.down then
		if f9_arg1.button == "shoulderl" then
			Engine.NotifyServer( "bot_select", -1 )
		elseif f9_arg1.button == "shoulderr" then
			Engine.NotifyServer( "bot_select", 1 )
		elseif f9_arg1.button == "primary" then
			f0_local12( f9_arg0, "a" )
			f0_local18( f9_arg0 )
			f0_local19( f9_arg0, f9_arg1 )
		elseif f9_arg1.button == "secondary" then
			f0_local12( f9_arg0, "b" )
			f0_local18( f9_arg0 )
			f0_local19( f9_arg0, f9_arg1 )
		elseif f9_arg1.button == "alt1" then
			f0_local12( f9_arg0, "x" )
			f0_local18( f9_arg0 )
			f0_local19( f9_arg0, f9_arg1 )
		elseif f9_arg1.button == "alt2" then
			f0_local12( f9_arg0, "a", 0 )
			f0_local12( f9_arg0, "b", 0 )
			f0_local12( f9_arg0, "x", 0 )
			f0_local12( f9_arg0, "y", 1 )
			f0_local19( f9_arg0, f9_arg1 )
		elseif f9_arg1.button == "select" then
			f9_arg0:dispatchEventToRoot( {
				name = "toggle_scoreboard"
			} )
		end
	end
end

local f0_local21 = function ( f10_arg0, f10_arg1 )
	if f10_arg1.down then
		if f10_arg1.button == "shoulderl" then
			Engine.NotifyServer( "bot_select", -1 )
		elseif f10_arg1.button == "shoulderr" then
			Engine.NotifyServer( "bot_select", 1 )
		elseif f10_arg1.button == "primary" then
			f0_local12( f10_arg0, "a", 1 )
			f0_local12( f10_arg0, "b", 0 )
			f0_local12( f10_arg0, "x", 0 )
			f0_local12( f10_arg0, "y", 0 )
			FireTeam.tactic_name = "@MPUI_FT_TACTIC_AMBUSH"
			Engine.NotifyServer( "tactic_select", 2 )
		elseif f10_arg1.button == "secondary" then
			f0_local12( f10_arg0, "a", 0 )
			f0_local12( f10_arg0, "b", 1 )
			f0_local12( f10_arg0, "x", 0 )
			f0_local12( f10_arg0, "y", 0 )
			FireTeam.tactic_name = "@MPUI_FT_TACTIC_BUDDY"
			Engine.NotifyServer( "tactic_select", 3 )
		elseif f10_arg1.button == "alt1" then
			f0_local12( f10_arg0, "a", 0 )
			f0_local12( f10_arg0, "b", 0 )
			f0_local12( f10_arg0, "x", 1 )
			f0_local12( f10_arg0, "y", 0 )
			FireTeam.tactic_name = "@MPUI_FT_TACTIC_HUNT"
			Engine.NotifyServer( "tactic_select", 4 )
		elseif f10_arg1.button == "alt2" then
			f0_local12( f10_arg0, "a", 0 )
			f0_local12( f10_arg0, "b", 0 )
			f0_local12( f10_arg0, "x", 0 )
			f0_local12( f10_arg0, "y", 1 )
			FireTeam.tactic_name = "@MPUI_FT_TACTIC_NONE"
			Engine.NotifyServer( "tactic_select", 1 )
		elseif f10_arg1.button == "select" then
			f10_arg0:dispatchEventToRoot( {
				name = "toggle_scoreboard"
			} )
		end
	end
end

local f0_local22 = function ( f11_arg0, f11_arg1 )
	Engine.NotifyServer( "tactics_menu", 0 )
	f0_local17( f11_arg0, nil )
	LUI.FlowManager.RequestCloseAllMenus( f11_arg0, nil )
end

local f0_local23 = function ()
	return {
		type = "UIText",
		id = "mp_fire_team_title",
		properties = {
			text = Engine.Localize( "@MPUI_FT_TACTICS" )
		},
		states = {
			default = {
				topAnchor = true,
				leftAnchor = true,
				bottomAnchor = false,
				rightAnchor = true,
				top = 0,
				height = 30,
				font = CoD.TextSettings.HudEuroBigFont.Font,
				alignment = LUI.Alignment.Center,
				alpha = 1
			}
		}
	}
end

local f0_local24 = function ()
	return {
		type = "UIImage",
		id = "mp_fire_team_bg",
		states = {
			default = {
				leftAnchor = true,
				topAnchor = true,
				rightAnchor = true,
				bottomAnchor = true,
				top = 0,
				left = 0,
				material = RegisterMaterial( "black" ),
				alpha = 0.7
			}
		}
	}
end

local f0_local25 = function ()
	return {
		type = "UIImage",
		id = "mp_fire_team_title_line",
		states = {
			default = {
				leftAnchor = true,
				rightAnchor = true,
				topAnchor = true,
				bottomAnchor = false,
				top = 30,
				height = 2,
				material = RegisterMaterial( "white" ),
				alpha = 0.3
			}
		}
	}
end

local f0_local26 = 0
local f0_local27 = 0
local f0_local28 = 24
local f0_local29 = 68
local f0_local30 = 80
local f0_local31 = 20
local f0_local32 = function ()
	local f15_local0 = {
		type = "UIElement",
		id = "mp_fire_team_menu_id",
		states = {
			default = {
				leftAnchor = true,
				topAnchor = true,
				rightAnchor = false,
				bottomAnchor = false,
				left = 110,
				top = 210,
				width = 0,
				height = 200,
				alpha = 0
			},
			opening = MBh.BaseState( "default", {
				width = 300,
				alpha = 0.25
			} ),
			active = MBh.BaseState( "default", {
				width = 280,
				alpha = 1
			} )
		}
	}
	local f15_local1 = {}
	local f15_local2 = f0_local24()
	local f15_local3 = f0_local25()
	local f15_local4 = f0_local23()
	local f15_local5 = f0_local14( "a", "@PLATFORM_UI_SELECTBUTTON", f0_local26, f0_local27 + f0_local28 )
	local f15_local6 = f0_local13( "a", "a", f0_local26, f0_local27 + f0_local29 )
	local f15_local7 = f0_local14( "b", "@PLATFORM_BACK_BUTTON", f0_local26 + f0_local28, f0_local27 )
	local f15_local8 = f0_local13( "b", "b", f0_local26 + f0_local29, f0_local27 )
	local f15_local9 = f0_local14( "x", "@PLATFORM_CHALLENGE_BLADE_BUTTON", f0_local26 - f0_local28, f0_local27 )
	local f15_local10 = f0_local13( "x", "c", f0_local26 - f0_local29, f0_local27 )
	local f15_local11 = f0_local14( "y", "@PLATFORM_Y_BUTTON", f0_local26, f0_local27 - f0_local28 )
	local f15_local12 = f0_local15( "y", "@MPUI_FT_TACTIC_NONE", f0_local26, f0_local27 - f0_local28 - f0_local31 - 8, LUI.Alignment.Center )
	local f15_local13 = f0_local14( "lb", "@PLATFORM_FB_PREV_PAGE_BUTTON", f0_local26 - f0_local30, f0_local27 - 50 )
	local f15_local14 = f0_local15( "lb", "@MPUI_FT_PREV", f0_local26 - f0_local30 - f0_local31, f0_local27 - 50, LUI.Alignment.Right )
	local f15_local15 = f0_local14( "rb", "@PLATFORM_FB_NEXT_PAGE_BUTTON", f0_local26 + f0_local30, f0_local27 - 50 )
	local f15_local16 = f0_local15( "rb", "@MPUI_FT_NEXT", f0_local26 + f0_local30 + f0_local31, f0_local27 - 50, LUI.Alignment.Left )
	f15_local0.children = f15_local2
	f15_local0.handlers = {
		menu_create = f0_local16,
		gamepad_button = f0_local20,
		toggle_scoreboard = f0_local22,
		mp_fire_team_on = MBh.AnimateSequence( {
			{
				"default",
				0
			},
			{
				"opening",
				125
			},
			{
				"active",
				125
			}
		} )
	}
	return f15_local0
end

local f0_local33 = 0
local f0_local34 = 15
local f0_local35 = 24
local f0_local36 = 80
local f0_local37 = 20
local f0_local38 = function ()
	local f16_local0 = {
		type = "UIElement",
		id = "mp_fire_team_menu_id",
		states = {
			default = {
				leftAnchor = true,
				topAnchor = true,
				rightAnchor = false,
				bottomAnchor = false,
				left = 110,
				top = 210,
				width = 0,
				height = 150,
				alpha = 0
			},
			opening = MBh.BaseState( "default", {
				width = 300,
				alpha = 0.25
			} ),
			active = MBh.BaseState( "default", {
				width = 280,
				alpha = 1
			} )
		}
	}
	local f16_local1 = {}
	local f16_local2 = f0_local24()
	local f16_local3 = f0_local25()
	local f16_local4 = f0_local23()
	local f16_local5 = f0_local14( "a", "@PLATFORM_UI_SELECTBUTTON", f0_local33, f0_local34 + f0_local35 )
	local f16_local6 = f0_local15( "a", "@MPUI_FT_TACTIC_AMBUSH", f0_local33, f0_local34 + f0_local35 + f0_local37 + 2, LUI.Alignment.Center )
	local f16_local7 = f0_local14( "b", "@PLATFORM_BACK_BUTTON", f0_local33 + f0_local35, f0_local34 )
	local f16_local8 = f0_local15( "b", "@MPUI_FT_TACTIC_BUDDY", f0_local33 + f0_local35 + f0_local37, f0_local34 - 8, LUI.Alignment.Left )
	local f16_local9 = f0_local14( "x", "@PLATFORM_CHALLENGE_BLADE_BUTTON", f0_local33 - f0_local35, f0_local34 )
	local f16_local10 = f0_local15( "x", "@MPUI_FT_TACTIC_HUNT", f0_local33 - f0_local35 - f0_local37, f0_local34 - 8, LUI.Alignment.Right )
	local f16_local11 = f0_local14( "y", "@PLATFORM_Y_BUTTON", f0_local33, f0_local34 - f0_local35 )
	local f16_local12 = f0_local15( "y", "@MPUI_FT_TACTIC_NONE", f0_local33, f0_local34 - f0_local35 - f0_local37 - 2, LUI.Alignment.Center )
	local f16_local13 = f0_local14( "lb", "@PLATFORM_FB_PREV_PAGE_BUTTON", f0_local33 - f0_local36, f0_local34 - 40 )
	local f16_local14 = f0_local15( "lb", "@MPUI_FT_PREV", f0_local33 - f0_local36 - f0_local37, f0_local34 - 40, LUI.Alignment.Right )
	local f16_local15 = f0_local14( "rb", "@PLATFORM_FB_NEXT_PAGE_BUTTON", f0_local33 + f0_local36, f0_local34 - 40 )
	local f16_local16 = f0_local15( "rb", "@MPUI_FT_NEXT", f0_local33 + f0_local36 + f0_local37, f0_local34 - 40, LUI.Alignment.Left )
	f16_local0.children = f16_local2
	f16_local0.handlers = {
		menu_create = f0_local16,
		gamepad_button = f0_local21,
		toggle_scoreboard = f0_local22,
		mp_fire_team_on = MBh.AnimateSequence( {
			{
				"default",
				0
			},
			{
				"opening",
				125
			},
			{
				"active",
				125
			}
		} )
	}
	return f16_local0
end

LUI.MenuBuilder.registerDef( "mp_fire_team_menu", f0_local32 )
LUI.MenuBuilder.registerDef( "mp_fire_team_menu_war", f0_local38 )
LockTable( _M )
