local f0_local0 = module
local f0_local1, f0_local2 = ...
f0_local0( f0_local1, package.seeall )
CoD.PrintModuleLoad( _NAME )
f0_local0 = function ()
	if Game.InKillCam() then
		if Game.IsCinematicCameraActive() then
			return false
		elseif Game.IsKillCamEntityActive() then
			return false
		end
	elseif Game.IsSpectatorCameraActive() then
		return false
	end
	return true
end

f0_local1 = function ( f2_arg0, f2_arg1 )
	if not f0_local0() then
		f2_arg0:dispatchEventToChildren( {
			name = "heliPilotOverlayDef_ended"
		} )
		f2_arg0:dispatchEventToChildren( {
			name = "predatorMissileOverlayDef_ended"
		} )
		f2_arg0:dispatchEventToChildren( {
			name = "odinOverlayDef_ended"
		} )
		f2_arg0:dispatchEventToChildren( {
			name = "juggernautOverlayDef_ended"
		} )
		f2_arg0:dispatchEventToChildren( {
			name = "a10OverlayDef_ended"
		} )
		f2_arg0:dispatchEventToChildren( {
			name = "vanguardOverlayDef_ended"
		} )
		f2_arg0:dispatchEventToChildren( {
			name = "juggPredatorOverlayDef_ended"
		} )
		f2_arg0:dispatchEventToChildren( {
			name = "ac130OverlayDef_ended"
		} )
	end
end

f0_local2 = function ( f3_arg0, f3_arg1 )
	local f3_local0 = f3_arg1.killstreak
	if f3_arg0.openOverlays[f3_local0] then
		return 
	elseif not f0_local0() then
		return 
	else
		local f3_local1 = LUI.MenuBuilder.buildItems( {
			type = f3_local0
		}, f3_arg0.properties, f3_arg0 )
		f3_local1:registerEventHandler( f3_local0 .. "_ended", function ( element, event )
			element:close()
			f3_arg0.openOverlays[f3_local0] = false
		end )
		f3_arg0.openOverlays[f3_local0] = true
		f3_arg0:addElement( f3_local1 )
		f3_local1:processEvent( {
			name = "init_overlay",
			omnvar = f3_arg1.omnvar,
			value = f3_arg1.value
		} )
	end
end

local f0_local3 = function ( f5_arg0, f5_arg1 )
	if f5_arg1.value == 1 then
		f5_arg0:dispatchEventToRoot( {
			name = "add_overlay",
			target = f5_arg0,
			killstreak = "heliPilotOverlayDef",
			omnvar = f5_arg1.omnvar,
			value = f5_arg1.value
		} )
	elseif f5_arg1.value == 0 then
		f5_arg0:dispatchEventToChildren( {
			name = "heliPilotOverlayDef_ended"
		} )
	end
end

local f0_local4 = function ( f6_arg0, f6_arg1 )
	if f6_arg1.value == 1 then
		f6_arg0:dispatchEventToRoot( {
			name = "add_overlay",
			target = f6_arg0,
			killstreak = "predatorMissileOverlayDef",
			omnvar = f6_arg1.omnvar,
			value = f6_arg1.value
		} )
	elseif f6_arg1.value == 0 then
		f6_arg0:dispatchEventToChildren( {
			name = "predatorMissileOverlayDef_ended"
		} )
	end
end

local f0_local5 = function ( f7_arg0, f7_arg1 )
	if f7_arg1.value == 1 or f7_arg1.value == 2 then
		f7_arg0:dispatchEventToRoot( {
			name = "add_overlay",
			target = f7_arg0,
			killstreak = "odinOverlayDef",
			omnvar = f7_arg1.omnvar,
			value = f7_arg1.value
		} )
	elseif f7_arg1.value == -1 then
		f7_arg0:dispatchEventToChildren( {
			name = "odinOverlayDef_ended"
		} )
	end
end

local f0_local6 = function ( f8_arg0, f8_arg1 )
	if f8_arg1.value == 1 then
		f8_arg0:dispatchEventToRoot( {
			name = "add_overlay",
			target = f8_arg0,
			killstreak = "juggernautOverlayDef",
			omnvar = f8_arg1.omnvar,
			value = f8_arg1.value
		} )
	elseif f8_arg1.value == 0 then
		f8_arg0:dispatchEventToChildren( {
			name = "juggernautOverlayDef_ended"
		} )
	end
end

local f0_local7 = function ( f9_arg0, f9_arg1 )
	if f9_arg1.value == true then
		f9_arg0:dispatchEventToRoot( {
			name = "add_overlay",
			target = f9_arg0,
			killstreak = "a10OverlayDef",
			omnvar = f9_arg1.omnvar,
			value = f9_arg1.value
		} )
	elseif f9_arg1.value == false then
		f9_arg0:dispatchEventToChildren( {
			name = "a10OverlayDef_ended"
		} )
	end
end

local f0_local8 = function ( f10_arg0, f10_arg1 )
	if f10_arg1.value == 1 then
		f10_arg0:dispatchEventToRoot( {
			name = "add_overlay",
			target = f10_arg0,
			killstreak = "vanguardOverlayDef",
			omnvar = f10_arg1.omnvar,
			value = f10_arg1.value
		} )
	elseif f10_arg1.value == 0 then
		f10_arg0:dispatchEventToChildren( {
			name = "vanguardOverlayDef_ended"
		} )
	end
end

local f0_local9 = function ( f11_arg0, f11_arg1 )
	if f11_arg1.value then
		f11_arg0:dispatchEventToRoot( {
			name = "add_overlay",
			target = f11_arg0,
			killstreak = "juggPredatorOverlayDef",
			omnvar = f11_arg1.omnvar,
			value = f11_arg1.value
		} )
	elseif not f11_arg1.value then
		f11_arg0:dispatchEventToChildren( {
			name = "juggPredatorOverlayDef_ended"
		} )
	end
end

local f0_local10 = function ( f12_arg0, f12_arg1 )
	if f12_arg1.value then
		f12_arg0:dispatchEventToRoot( {
			name = "add_overlay",
			target = f12_arg0,
			killstreak = "ac130OverlayDef",
			omnvar = f12_arg1.omnvar,
			value = f12_arg1.value
		} )
	elseif not f12_arg1.value then
		f12_arg0:dispatchEventToChildren( {
			name = "ac130OverlayDef_ended"
		} )
	end
end

local f0_local11 = function ( f13_arg0, f13_arg1 )
	local f13_local0 = Game.GetOmnvar( "ui_heli_pilot" )
	local f13_local1 = Game.GetOmnvar( "ui_predator_missile" )
	local f13_local2 = Game.GetOmnvar( "ui_odin" )
	local f13_local3 = Game.GetOmnvar( "ui_juggernaut" )
	local f13_local4 = Game.GetOmnvar( "ui_a10" )
	local f13_local5 = Game.GetOmnvar( "ui_vanguard" )
	local f13_local6 = Game.GetOmnvar( "ui_predator_hud" )
	local f13_local7 = Game.GetOmnvar( "ui_ac130_hud" )
	f0_local3( f13_arg0, {
		name = "ui_heli_pilot",
		value = f13_local0
	} )
	f0_local4( f13_arg0, {
		name = "ui_predator_missile",
		value = f13_local1
	} )
	f0_local5( f13_arg0, {
		name = "ui_odin",
		value = f13_local2
	} )
	f0_local6( f13_arg0, {
		name = "ui_juggernaut",
		value = f13_local3
	} )
	f0_local7( f13_arg0, {
		name = "ui_a10",
		value = f13_local4
	} )
	f0_local8( f13_arg0, {
		name = "ui_vanguard",
		value = f13_local5
	} )
	f0_local9( f13_arg0, {
		name = "ui_predator_hud",
		value = f13_local6
	} )
	f0_local10( f13_arg0, {
		name = "ui_ac130_hud",
		value = f13_local7
	} )
end

local f0_local12 = function ( f14_arg0, f14_arg1 )
	local f14_local0 = f14_arg0:getFirstChild()
	while f14_local0 do
		f14_local0:processEvent( f14_arg1 )
		f14_local0 = f14_local0:getNextSibling()
	end
end

LUI.MenuBuilder.registerType( "overlayHudDef", function ()
	local self = LUI.UIElement.new( {
		topAnchor = true,
		leftAnchor = true,
		bottomAnchor = true,
		rightAnchor = true,
		top = 0,
		left = 0,
		bottom = 0,
		right = 0
	} )
	self.id = "overlayId"
	self.openOverlays = {}
	self:registerOmnvarHandler( "ui_heli_pilot", f0_local3 )
	self:registerOmnvarHandler( "ui_predator_missile", f0_local4 )
	self:registerOmnvarHandler( "ui_odin", f0_local5 )
	self:registerOmnvarHandler( "ui_juggernaut", f0_local6 )
	self:registerOmnvarHandler( "ui_a10", f0_local7 )
	self:registerOmnvarHandler( "ui_vanguard", f0_local8 )
	self:registerOmnvarHandler( "ui_predator_hud", f0_local9 )
	self:registerOmnvarHandler( "ui_ac130_hud", f0_local10 )
	self:registerEventHandler( "add_overlay", f0_local2 )
	self:registerEventHandler( "playerstate_client_changed", f0_local11 )
	self:registerEventHandler( "refresh_controls", f0_local12 )
	self:registerEventHandler( "camera_client_changed", f0_local1 )
	return self
end )
LockTable( _M )
