local f0_local0 = module
local f0_local1, f0_local2 = ...
f0_local0( f0_local1, package.seeall )
CoD.PrintModuleLoad( _NAME )
Settings = {
	Header = {
		TextStart = 100
	}
}
function leaderboards_selection_vlist()
	return {
		type = "UIScrollingVerticalList",
		id = "leaderboards_vlist_id",
		properties = {
			use_arrows = true
		},
		childrenFeeder = LeaderboardsSelectionFeeder,
		states = {
			default = {
				leftAnchor = true,
				rightAnchor = false,
				topAnchor = true,
				bottomAnchor = false,
				left = GenericMenuDims.menu_left,
				right = GenericMenuDims.menu_right,
				top = GenericMenuDims.menu_top,
				bottom = GenericMenuDims.menu_top + GenericButtonSettings.Styles.GradientButton.height * 10 + 2 + 60
			}
		}
	}
end

function leaderboards_alien_extinction_selection_vlist()
	return {
		type = "UIScrollingVerticalList",
		id = "leaderboards_alien_extinction_selection_vlist_id",
		properties = {
			use_arrows = true
		},
		childrenFeeder = LeaderboardsSelectionAlienExtinctionFeeder,
		states = {
			default = {
				leftAnchor = true,
				rightAnchor = false,
				topAnchor = true,
				bottomAnchor = false,
				left = GenericMenuDims.menu_left,
				right = GenericMenuDims.menu_right,
				top = GenericMenuDims.menu_top,
				bottom = GenericMenuDims.menu_top + GenericButtonSettings.Styles.GradientButton.height * 10 + 2 + 60
			}
		}
	}
end

function leaderboards_alien_chaos_selection_vlist()
	return {
		type = "UIScrollingVerticalList",
		id = "leaderboards_alien_chaos_selection_vlist_id",
		properties = {
			use_arrows = true
		},
		childrenFeeder = LeaderboardsSelectionAlienChaosFeeder,
		states = {
			default = {
				leftAnchor = true,
				rightAnchor = false,
				topAnchor = true,
				bottomAnchor = false,
				left = GenericMenuDims.menu_left,
				right = GenericMenuDims.menu_right,
				top = GenericMenuDims.menu_top,
				bottom = GenericMenuDims.menu_top + GenericButtonSettings.Styles.GradientButton.height * 10 + 2 + 60
			}
		}
	}
end

function leaderboards_alien_ex_global_selection_vlist()
	return {
		type = "UIScrollingVerticalList",
		id = "leaderboards_alien_ex_global_selection_vlist_id",
		properties = {
			use_arrows = true
		},
		childrenFeeder = LeaderboardsSelectionAlienExtinctionGlobalFeeder,
		states = {
			default = {
				leftAnchor = true,
				rightAnchor = false,
				topAnchor = true,
				bottomAnchor = false,
				left = GenericMenuDims.menu_left,
				right = GenericMenuDims.menu_right,
				top = GenericMenuDims.menu_top,
				bottom = GenericMenuDims.menu_top + GenericButtonSettings.Styles.GradientButton.height * 10 + 2 + 60
			}
		}
	}
end

function leaderboards_alien_chaos_global_selection_vlist()
	return {
		type = "UIScrollingVerticalList",
		id = "leaderboards_alien_chaos_global_selection_vlist_id",
		properties = {
			use_arrows = true
		},
		childrenFeeder = LeaderboardsSelectionAlienChaosGlobalFeeder,
		states = {
			default = {
				leftAnchor = true,
				rightAnchor = false,
				topAnchor = true,
				bottomAnchor = false,
				left = GenericMenuDims.menu_left,
				right = GenericMenuDims.menu_right,
				top = GenericMenuDims.menu_top,
				bottom = GenericMenuDims.menu_top + GenericButtonSettings.Styles.GradientButton.height * 10 + 2 + 60
			}
		}
	}
end

function leaderboards_alien_ex_poc_selection_vlist()
	return {
		type = "UIScrollingVerticalList",
		id = "leaderboards_alien_ex_poc_selection_vlist_id",
		properties = {
			use_arrows = true
		},
		childrenFeeder = LeaderboardsSelectionAlienExPOCFeeder,
		states = {
			default = {
				leftAnchor = true,
				rightAnchor = false,
				topAnchor = true,
				bottomAnchor = false,
				left = GenericMenuDims.menu_left,
				right = GenericMenuDims.menu_right,
				top = GenericMenuDims.menu_top,
				bottom = GenericMenuDims.menu_top + GenericButtonSettings.Styles.GradientButton.height * 10 + 2 + 60
			}
		}
	}
end

function leaderboards_alien_chaos_poc_selection_vlist()
	return {
		type = "UIScrollingVerticalList",
		id = "leaderboards_alien_chaos_poc_selection_vlist_id",
		properties = {
			use_arrows = true
		},
		childrenFeeder = LeaderboardsSelectionAlienChaosPOCFeeder,
		states = {
			default = {
				leftAnchor = true,
				rightAnchor = false,
				topAnchor = true,
				bottomAnchor = false,
				left = GenericMenuDims.menu_left,
				right = GenericMenuDims.menu_right,
				top = GenericMenuDims.menu_top,
				bottom = GenericMenuDims.menu_top + GenericButtonSettings.Styles.GradientButton.height * 10 + 2 + 60
			}
		}
	}
end

function leaderboards_alien_ex_nightfall_selection_vlist()
	return {
		type = "UIScrollingVerticalList",
		id = "leaderboards_alien_ex_nightfall_selection_vlist_id",
		properties = {
			use_arrows = true
		},
		childrenFeeder = LeaderboardsSelectionAlienExNightfallFeeder,
		states = {
			default = {
				leftAnchor = true,
				rightAnchor = false,
				topAnchor = true,
				bottomAnchor = false,
				left = GenericMenuDims.menu_left,
				right = GenericMenuDims.menu_right,
				top = GenericMenuDims.menu_top,
				bottom = GenericMenuDims.menu_top + GenericButtonSettings.Styles.GradientButton.height * 10 + 2 + 60
			}
		}
	}
end

function leaderboards_alien_chaos_nightfall_selection_vlist()
	return {
		type = "UIScrollingVerticalList",
		id = "leaderboards_alien_chaos_nightfall_selection_vlist_id",
		properties = {
			use_arrows = true
		},
		childrenFeeder = LeaderboardsSelectionAlienChaosNightfallFeeder,
		states = {
			default = {
				leftAnchor = true,
				rightAnchor = false,
				topAnchor = true,
				bottomAnchor = false,
				left = GenericMenuDims.menu_left,
				right = GenericMenuDims.menu_right,
				top = GenericMenuDims.menu_top,
				bottom = GenericMenuDims.menu_top + GenericButtonSettings.Styles.GradientButton.height * 10 + 2 + 60
			}
		}
	}
end

function leaderboards_alien_ex_mayday_selection_vlist()
	return {
		type = "UIScrollingVerticalList",
		id = "leaderboards_alien_ex_mayday_selection_vlist_id",
		properties = {
			use_arrows = true
		},
		childrenFeeder = LeaderboardsSelectionAlienExMaydayFeeder,
		states = {
			default = {
				leftAnchor = true,
				rightAnchor = false,
				topAnchor = true,
				bottomAnchor = false,
				left = GenericMenuDims.menu_left,
				right = GenericMenuDims.menu_right,
				top = GenericMenuDims.menu_top,
				bottom = GenericMenuDims.menu_top + GenericButtonSettings.Styles.GradientButton.height * 10 + 2 + 60
			}
		}
	}
end

function leaderboards_alien_chaos_mayday_selection_vlist()
	return {
		type = "UIScrollingVerticalList",
		id = "leaderboards_alien_chaos_mayday_selection_vlist_id",
		properties = {
			use_arrows = true
		},
		childrenFeeder = LeaderboardsSelectionAlienChaosMaydayFeeder,
		states = {
			default = {
				leftAnchor = true,
				rightAnchor = false,
				topAnchor = true,
				bottomAnchor = false,
				left = GenericMenuDims.menu_left,
				right = GenericMenuDims.menu_right,
				top = GenericMenuDims.menu_top,
				bottom = GenericMenuDims.menu_top + GenericButtonSettings.Styles.GradientButton.height * 10 + 2 + 60
			}
		}
	}
end

function leaderboards_alien_ex_dlc3_selection_vlist()
	return {
		type = "UIScrollingVerticalList",
		id = "leaderboards_alien_ex_dlc3_selection_vlist_id",
		properties = {
			use_arrows = true
		},
		childrenFeeder = LeaderboardsSelectionAlienExDlc3Feeder,
		states = {
			default = {
				leftAnchor = true,
				rightAnchor = false,
				topAnchor = true,
				bottomAnchor = false,
				left = GenericMenuDims.menu_left,
				right = GenericMenuDims.menu_right,
				top = GenericMenuDims.menu_top,
				bottom = GenericMenuDims.menu_top + GenericButtonSettings.Styles.GradientButton.height * 10 + 2 + 60
			}
		}
	}
end

function leaderboards_alien_chaos_dlc3_selection_vlist()
	return {
		type = "UIScrollingVerticalList",
		id = "leaderboards_alien_chaos_dlc3_selection_vlist_id",
		properties = {
			use_arrows = true
		},
		childrenFeeder = LeaderboardsSelectionAlienChaosDlc3Feeder,
		states = {
			default = {
				leftAnchor = true,
				rightAnchor = false,
				topAnchor = true,
				bottomAnchor = false,
				left = GenericMenuDims.menu_left,
				right = GenericMenuDims.menu_right,
				top = GenericMenuDims.menu_top,
				bottom = GenericMenuDims.menu_top + GenericButtonSettings.Styles.GradientButton.height * 10 + 2 + 60
			}
		}
	}
end

function leaderboards_alien_ex_last_selection_vlist()
	return {
		type = "UIScrollingVerticalList",
		id = "leaderboards_alien_ex_last_selection_vlist_id",
		properties = {
			use_arrows = true
		},
		childrenFeeder = LeaderboardsSelectionAlienExLastFeeder,
		states = {
			default = {
				leftAnchor = true,
				rightAnchor = false,
				topAnchor = true,
				bottomAnchor = false,
				left = GenericMenuDims.menu_left,
				right = GenericMenuDims.menu_right,
				top = GenericMenuDims.menu_top,
				bottom = GenericMenuDims.menu_top + GenericButtonSettings.Styles.GradientButton.height * 10 + 2 + 60
			}
		}
	}
end

function leaderboards_alien_chaos_last_selection_vlist()
	return {
		type = "UIScrollingVerticalList",
		id = "leaderboards_alien_chaos_last_selection_vlist_id",
		properties = {
			use_arrows = true
		},
		childrenFeeder = LeaderboardsSelectionAlienChaosLastFeeder,
		states = {
			default = {
				leftAnchor = true,
				rightAnchor = false,
				topAnchor = true,
				bottomAnchor = false,
				left = GenericMenuDims.menu_left,
				right = GenericMenuDims.menu_right,
				top = GenericMenuDims.menu_top,
				bottom = GenericMenuDims.menu_top + GenericButtonSettings.Styles.GradientButton.height * 10 + 2 + 60
			}
		}
	}
end

function LeaderboardAction( f16_arg0, f16_arg1 )
	LUI.FlowManager.RequestPopupMenu( f16_arg0, "mp_leaderboard_main", true, f16_arg1.controller, false, {
		leaderboardType = f16_arg0.properties.leaderboardType,
		filterType = f16_arg0.properties.filterType
	} )
end

function LeaderboardsSelectionFeeder( f17_arg0 )
	local f17_local0 = nil
	local f17_local1 = LUI.Alignment.Right
	if Engine.IsAliensMode() then
		f17_local0 = {
			{
				type = "UIGenericButton",
				id = "by_aliens_global_button_id",
				properties = {
					button_text = Engine.Localize( "@LUA_MENU_ALIENS" ),
					desc_text = Engine.Localize( "@LUA_MENU_MP_DESC_LEADERBOARD_EXTINCTION" ),
					button_action_func = function ( f18_arg0, f18_arg1 )
						if Engine.IsUserAGuest( f18_arg1.controller ) then
							LUI.FlowManager.RequestPopupMenu( f18_arg0, "popup_no_guest", true, f18_arg1.controller )
						else
							LUI.FlowManager.RequestAddMenu( f18_arg0, "leaderboards_alien_extinction", true, f18_arg1.controller )
						end
					end
				}
			},
			{
				type = "UIGenericButton",
				id = "by_aliens_chaos_button_id",
				properties = {
					button_text = Engine.Localize( "@LUA_MENU_MP_CHAOS_MODE" ),
					desc_text = Engine.Localize( "@LUA_MENU_MP_DESC_LEADERBOARD_CHAOS" ),
					button_action_func = function ( f19_arg0, f19_arg1 )
						if Engine.IsUserAGuest( f19_arg1.controller ) then
							LUI.FlowManager.RequestPopupMenu( f19_arg0, "popup_no_guest", true, f19_arg1.controller )
						else
							LUI.FlowManager.RequestAddMenu( f19_arg0, "leaderboards_alien_chaos", true, f19_arg1.controller )
						end
					end
				}
			}
		}
	elseif SvS.IsSvS() then
		f17_local0 = {
			{
				type = "UIGenericButton",
				id = "by_squad_assault_button_id",
				properties = {
					leaderboardType = "SquadAssault",
					filterType = "Friends",
					button_text = Engine.Localize( "@LUA_MENU_SQUAD_ASSAULT_CAPS" ),
					button_action_func = LeaderboardAction,
					desc_text = Engine.Localize( "@LUA_MENU_DESC_LEADERBOARD_SQUAD_ASSAULT" )
				}
			},
			{
				type = "UIGenericButton",
				id = "by_safeguard_button_id",
				properties = {
					leaderboardType = "Safeguard",
					filterType = "Friends",
					button_text = Engine.Localize( "@LUA_MENU_HORDE_CAPS" ),
					button_action_func = LeaderboardAction,
					desc_text = Engine.Localize( "@LUA_MENU_DESC_LEADERBOARD_HORDE" )
				}
			}
		}
	else
		f17_local0 = {
			{
				type = "UIGenericButton",
				id = "by_score_button_id",
				properties = {
					leaderboardType = "Score",
					filterType = "Friends",
					button_text = Engine.Localize( "@LUA_MENU_SCORE_CAPS" ),
					button_action_func = LeaderboardAction,
					desc_text = Engine.Localize( "@LUA_MENU_CHECK_HOW_YOUR_SCORE" )
				}
			},
			{
				type = "UIGenericButton",
				id = "by_wins_button_id",
				properties = {
					leaderboardType = "Wins",
					filterType = "Friends",
					button_text = Engine.Localize( "@LUA_MENU_WINS_CAPS" ),
					button_action_func = LeaderboardAction,
					desc_text = Engine.Localize( "@LUA_MENU_DESC_LEADERBOARD_WINS" )
				}
			},
			{
				type = "UIGenericButton",
				id = "by_kills_button_id",
				properties = {
					leaderboardType = "Kills",
					filterType = "Friends",
					button_action_func = LeaderboardAction,
					button_text = Engine.Localize( "@LUA_MENU_KILLS_CAPS" ),
					desc_text = Engine.Localize( "@LUA_MENU_DESC_LEADERBOARD_KILLS" )
				}
			},
			{
				type = "UIGenericButton",
				id = "by_accuracy_button_id",
				properties = {
					leaderboardType = "Accuracy",
					filterType = "Friends",
					button_action_func = LeaderboardAction,
					button_text = Engine.Localize( "@LUA_MENU_ACCURACY_CAPS" ),
					desc_text = Engine.Localize( "@LUA_MENU_DESC_LEADERBOARD_ACCURACY" )
				}
			},
			{
				type = "UIGenericButton",
				id = "by_dm_button_id",
				properties = {
					leaderboardType = "FreeForAll",
					filterType = "Friends",
					button_action_func = LeaderboardAction,
					button_text = Engine.Localize( "@LUA_MENU_DEATHMATCH_CAPS" ),
					desc_text = Engine.Localize( "@LUA_MENU_DESC_LEADERBOARD_DM" )
				}
			},
			{
				type = "UIGenericButton",
				id = "by_war_button_id",
				properties = {
					leaderboardType = "TeamDeathmatch",
					filterType = "Friends",
					button_action_func = LeaderboardAction,
					button_text = Engine.Localize( "@LUA_MENU_TEAM_DEATHMATCH_CAPS" ),
					desc_text = Engine.Localize( "@LUA_MENU_DESC_LEADERBOARD_WAR" )
				}
			},
			{
				type = "UIGenericButton",
				id = "by_gun_button_id",
				properties = {
					leaderboardType = "GunGame",
					filterType = "Friends",
					button_action_func = LeaderboardAction,
					button_text = Engine.Localize( "@LUA_MENU_GUN_CAPS" ),
					desc_text = Engine.Localize( "@LUA_MENU_MP_DESC_LEADERBOARD_GUN" )
				}
			},
			{
				type = "UIGenericButton",
				id = "by_sr_button_id",
				properties = {
					leaderboardType = "SearchAndRescue",
					filterType = "Friends",
					button_action_func = LeaderboardAction,
					button_text = Engine.Localize( "@LUA_MENU_SR_CAPS" ),
					desc_text = Engine.Localize( "@LUA_MENU_DESC_LEADERBOARD_SR" )
				}
			},
			{
				type = "UIGenericButton",
				id = "by_dom_button_id",
				properties = {
					leaderboardType = "Domination",
					filterType = "Friends",
					button_action_func = LeaderboardAction,
					button_text = Engine.Localize( "@LUA_MENU_DOMINATION_CAPS" ),
					desc_text = Engine.Localize( "@LUA_MENU_DESC_LEADERBOARD_DOM" )
				}
			},
			{
				type = "UIGenericButton",
				id = "by_conf_button_id",
				properties = {
					leaderboardType = "KillConfirmed",
					filterType = "Friends",
					button_action_func = LeaderboardAction,
					button_text = Engine.Localize( "@LUA_MENU_CONF_CAPS" ),
					desc_text = Engine.Localize( "@LUA_MENU_DESC_LEADERBOARD_CONF" )
				}
			},
			{
				type = "UIGenericButton",
				id = "by_blitz_button_id",
				properties = {
					leaderboardType = "Blitz",
					filterType = "Friends",
					button_action_func = LeaderboardAction,
					button_text = Engine.Localize( "@LUA_MENU_BLITZ_CAPS" ),
					desc_text = Engine.Localize( "@LUA_MENU_DESC_LEADERBOARD_BLITZ" )
				}
			},
			{
				type = "UIGenericButton",
				id = "by_cranked_button_id",
				properties = {
					leaderboardType = "Cranked",
					filterType = "Friends",
					button_action_func = LeaderboardAction,
					button_text = Engine.Localize( "@LUA_MENU_CRANKED_CAPS" ),
					desc_text = Engine.Localize( "@LUA_MENU_DESC_LEADERBOARD_CRANKED" )
				}
			},
			{
				type = "UIGenericButton",
				id = "by_huntedffa_button_id",
				properties = {
					leaderboardType = "HuntedFFA",
					filterType = "Friends",
					button_action_func = LeaderboardAction,
					button_text = Engine.Localize( "@LUA_MENU_SOTF_FFA_CAPS" ),
					desc_text = Engine.Localize( "@LUA_MENU_DESC_LEADERBOARD_SOTF_FFA" )
				}
			},
			{
				type = "UIGenericButton",
				id = "by_infected_button_id",
				properties = {
					leaderboardType = "Infected",
					filterType = "Friends",
					button_action_func = LeaderboardAction,
					button_text = Engine.Localize( "@LUA_MENU_INFECT_CAPS" ),
					desc_text = Engine.Localize( "@LUA_MENU_DESC_LEADERBOARD_INFECT" )
				}
			},
			{
				type = "UIGenericButton",
				id = "by_sd_button_id",
				properties = {
					leaderboardType = "SearchAndDestroy",
					filterType = "Friends",
					button_action_func = LeaderboardAction,
					button_text = Engine.Localize( "@LUA_MENU_SEARCH_AND_DESTROY_CAPS" ),
					desc_text = Engine.Localize( "@LUA_MENU_DESC_LEADERBOARD_SD" )
				}
			},
			{
				type = "UIGenericButton",
				id = "by_grnd_button_id",
				properties = {
					leaderboardType = "DropZone",
					filterType = "Friends",
					button_action_func = LeaderboardAction,
					button_text = Engine.Localize( "@MPUI_GRND_CAPS" ),
					desc_text = Engine.Localize( "@LUA_MENU_MP_DESC_LEADERBOARD_GRND" )
				}
			},
			{
				type = "UIGenericButton",
				id = "by_siege_button_id",
				properties = {
					leaderboardType = "Reinforce",
					filterType = "Friends",
					button_action_func = LeaderboardAction,
					button_text = Engine.Localize( "@LUA_MENU_MP_SIEGE_CAPS" ),
					desc_text = Engine.Localize( "@LUA_MENU_MP_DESC_LEADERBOARD_REINFORCE" )
				}
			}
		}
	end
	return f17_local0
end

function LeaderboardsSelectionAlienExtinctionFeeder( f20_arg0 )
	local f20_local0 = nil
	local f20_local1 = LUI.Alignment.Right
	return {
		{
			type = "UIGenericButton",
			id = "by_aliens_ex_global_button_id",
			properties = {
				button_text = Engine.Localize( "@LUA_MENU_MP_LEADERBOARD_GLOBAL" ),
				desc_text = Engine.Localize( "@LUA_MENU_MP_DESC_LEADERBOARD_GLOBAL" ),
				button_action_func = function ( f21_arg0, f21_arg1 )
					if Engine.IsUserAGuest( f21_arg1.controller ) then
						LUI.FlowManager.RequestPopupMenu( f21_arg0, "popup_no_guest", true, f21_arg1.controller )
					else
						LUI.FlowManager.RequestAddMenu( f21_arg0, "leaderboards_alien_ex_global", true, f21_arg1.controller )
					end
				end
				
			}
		},
		{
			type = "UIGenericButton",
			id = "by_aliens_ex_poc_button_id",
			properties = {
				button_text = Engine.Localize( "@LUA_MENU_MP_LEADERBOARD_POC" ),
				desc_text = Engine.Localize( "@LUA_MENU_MP_DESC_LEADERBOARDS_POC" ),
				button_action_func = function ( f22_arg0, f22_arg1 )
					if Engine.IsUserAGuest( f22_arg1.controller ) then
						LUI.FlowManager.RequestPopupMenu( f22_arg0, "popup_no_guest", true, f22_arg1.controller )
					else
						LUI.FlowManager.RequestAddMenu( f22_arg0, "leaderboards_alien_ex_poc", true, f22_arg1.controller )
					end
				end
				
			}
		},
		{
			type = "UIGenericButton",
			id = "by_aliens_ex_nightfall_button_id",
			properties = {
				button_text = Engine.Localize( "@LUA_MENU_MP_LEADERBOARD_NIGHTFALL" ),
				desc_text = Engine.Localize( "@LUA_MENU_MP_DESC_LEADERBOARD_NIGHTFALL" ),
				button_action_func = function ( f23_arg0, f23_arg1 )
					if Engine.IsUserAGuest( f23_arg1.controller ) then
						LUI.FlowManager.RequestPopupMenu( f23_arg0, "popup_no_guest", true, f23_arg1.controller )
					else
						LUI.FlowManager.RequestAddMenu( f23_arg0, "leaderboards_alien_ex_nightfall", true, f23_arg1.controller )
					end
				end
				
			}
		},
		{
			type = "UIGenericButton",
			id = "by_aliens_ex_mayday_button_id",
			properties = {
				button_text = Engine.Localize( "@LUA_MENU_MP_LEADERBOARD_MAYDAY" ),
				desc_text = Engine.Localize( "@LUA_MENU_MP_DESC_LEADERBOARD_MAYDAY" ),
				button_action_func = function ( f24_arg0, f24_arg1 )
					if Engine.IsUserAGuest( f24_arg1.controller ) then
						LUI.FlowManager.RequestPopupMenu( f24_arg0, "popup_no_guest", true, f24_arg1.controller )
					else
						LUI.FlowManager.RequestAddMenu( f24_arg0, "leaderboards_alien_ex_mayday", true, f24_arg1.controller )
					end
				end
				
			}
		},
		{
			type = "UIGenericButton",
			id = "by_aliens_ex_dlc3_button_id",
			properties = {
				button_text = Engine.Localize( "@LUA_MENU_MP_LEADERBOARD_DLC3" ),
				desc_text = Engine.Localize( "@LUA_MENU_MP_DESC_LEADERBOARD_DLC3" ),
				button_action_func = function ( f25_arg0, f25_arg1 )
					if Engine.IsUserAGuest( f25_arg1.controller ) then
						LUI.FlowManager.RequestPopupMenu( f25_arg0, "popup_no_guest", true, f25_arg1.controller )
					else
						LUI.FlowManager.RequestAddMenu( f25_arg0, "leaderboards_alien_ex_dlc3", true, f25_arg1.controller )
					end
				end
				
			}
		},
		{
			type = "UIGenericButton",
			id = "by_aliens_ex_last_button_id",
			properties = {
				button_text = Engine.Localize( "@LUA_MENU_MP_LEADERBOARD_LAST" ),
				desc_text = Engine.Localize( "@LUA_MENU_MP_DESC_LEADERBOARD_LAST" ),
				button_action_func = function ( f26_arg0, f26_arg1 )
					if Engine.IsUserAGuest( f26_arg1.controller ) then
						LUI.FlowManager.RequestPopupMenu( f26_arg0, "popup_no_guest", true, f26_arg1.controller )
					else
						LUI.FlowManager.RequestAddMenu( f26_arg0, "leaderboards_alien_ex_last", true, f26_arg1.controller )
					end
				end
				
			}
		}
	}
end

function LeaderboardsSelectionAlienChaosFeeder( f27_arg0 )
	local f27_local0 = nil
	local f27_local1 = LUI.Alignment.Right
	return {
		{
			type = "UIGenericButton",
			id = "by_aliens_chaos_global_button_id",
			properties = {
				button_text = Engine.Localize( "@LUA_MENU_MP_LEADERBOARD_GLOBAL" ),
				desc_text = Engine.Localize( "@LUA_MENU_MP_DESC_LEADERBOARD_CHAOS_GLOBAL" ),
				button_action_func = function ( f28_arg0, f28_arg1 )
					if Engine.IsUserAGuest( f28_arg1.controller ) then
						LUI.FlowManager.RequestPopupMenu( f28_arg0, "popup_no_guest", true, f28_arg1.controller )
					else
						LUI.FlowManager.RequestAddMenu( f28_arg0, "leaderboards_alien_chaos_global", true, f28_arg1.controller )
					end
				end
				
			}
		},
		{
			type = "UIGenericButton",
			id = "by_aliens_chaos_poc_button_id",
			properties = {
				button_text = Engine.Localize( "@LUA_MENU_MP_LEADERBOARD_POC" ),
				desc_text = Engine.Localize( "@LUA_MENU_MP_DESC_LEADERBOARD_CHAOS_POC" ),
				button_action_func = function ( f29_arg0, f29_arg1 )
					if Engine.IsUserAGuest( f29_arg1.controller ) then
						LUI.FlowManager.RequestPopupMenu( f29_arg0, "popup_no_guest", true, f29_arg1.controller )
					else
						LUI.FlowManager.RequestAddMenu( f29_arg0, "leaderboards_alien_chaos_poc", true, f29_arg1.controller )
					end
				end
				
			}
		},
		{
			type = "UIGenericButton",
			id = "by_aliens_chaos_nightfall_button_id",
			properties = {
				button_text = Engine.Localize( "@LUA_MENU_MP_LEADERBOARD_NIGHTFALL" ),
				desc_text = Engine.Localize( "@LUA_MENU_MP_DESC_LEADERBOARD_CHAOS_NIGHTFALL" ),
				button_action_func = function ( f30_arg0, f30_arg1 )
					if Engine.IsUserAGuest( f30_arg1.controller ) then
						LUI.FlowManager.RequestPopupMenu( f30_arg0, "popup_no_guest", true, f30_arg1.controller )
					else
						LUI.FlowManager.RequestAddMenu( f30_arg0, "leaderboards_alien_chaos_nightfall", true, f30_arg1.controller )
					end
				end
				
			}
		},
		{
			type = "UIGenericButton",
			id = "by_aliens_chaos_mayday_button_id",
			properties = {
				button_text = Engine.Localize( "@LUA_MENU_MP_LEADERBOARD_MAYDAY" ),
				desc_text = Engine.Localize( "@LUA_MENU_MP_DESC_LEADERBOARD_CHAOS_MAYDAY" ),
				button_action_func = function ( f31_arg0, f31_arg1 )
					if Engine.IsUserAGuest( f31_arg1.controller ) then
						LUI.FlowManager.RequestPopupMenu( f31_arg0, "popup_no_guest", true, f31_arg1.controller )
					else
						LUI.FlowManager.RequestAddMenu( f31_arg0, "leaderboards_alien_chaos_mayday", true, f31_arg1.controller )
					end
				end
				
			}
		},
		{
			type = "UIGenericButton",
			id = "by_aliens_chaos_dlc3_button_id",
			properties = {
				button_text = Engine.Localize( "@LUA_MENU_MP_LEADERBOARD_DLC3" ),
				desc_text = Engine.Localize( "@LUA_MENU_MP_DESC_LEADERBOARD_CHAOS_DLC3" ),
				button_action_func = function ( f32_arg0, f32_arg1 )
					if Engine.IsUserAGuest( f32_arg1.controller ) then
						LUI.FlowManager.RequestPopupMenu( f32_arg0, "popup_no_guest", true, f32_arg1.controller )
					else
						LUI.FlowManager.RequestAddMenu( f32_arg0, "leaderboards_alien_chaos_dlc3", true, f32_arg1.controller )
					end
				end
				
			}
		},
		{
			type = "UIGenericButton",
			id = "by_aliens_chaos_last_button_id",
			properties = {
				button_text = Engine.Localize( "@LUA_MENU_MP_LEADERBOARD_LAST" ),
				desc_text = Engine.Localize( "@LUA_MENU_MP_DESC_LEADERBOARD_CHAOS_LAST" ),
				button_action_func = function ( f33_arg0, f33_arg1 )
					if Engine.IsUserAGuest( f33_arg1.controller ) then
						LUI.FlowManager.RequestPopupMenu( f33_arg0, "popup_no_guest", true, f33_arg1.controller )
					else
						LUI.FlowManager.RequestAddMenu( f33_arg0, "leaderboards_alien_chaos_last", true, f33_arg1.controller )
					end
				end
				
			}
		}
	}
end

function LeaderboardsSelectionAlienExtinctionGlobalFeeder( f34_arg0 )
	local f34_local0 = nil
	local f34_local1 = LUI.Alignment.Right
	f34_local0 = {
		[#f34_local0 + 1] = {
			type = "UIGenericButton",
			id = "by_aliens_score_button_id",
			properties = {
				leaderboardType = "AlienScore",
				filterType = "Friends",
				button_text = Engine.Localize( "@LUA_MENU_SCORE_CAPS" ),
				button_action_func = LeaderboardAction,
				desc_text = Engine.Localize( "@LUA_MENU_DESC_LEADERBOARD_SCORE" )
			}
		},
		[#f34_local0 + 1] = {
			type = "UIGenericButton",
			id = "by_aliens_kills_button_id",
			properties = {
				leaderboardType = "AlienKills",
				filterType = "Friends",
				button_text = Engine.Localize( "@LUA_MENU_KILLS_CAPS" ),
				button_action_func = LeaderboardAction,
				desc_text = Engine.Localize( "@LUA_MENU_DESC_LEADERBOARD_ALIENKILLS" )
			}
		},
		[#f34_local0 + 1] = {
			type = "UIGenericButton",
			id = "by_aliens_hives_button_id",
			properties = {
				leaderboardType = "AlienHives",
				filterType = "Friends",
				button_text = Engine.Localize( "@LUA_MENU_HIVES_CAPS" ),
				button_action_func = LeaderboardAction,
				desc_text = Engine.Localize( "@LUA_MENU_DESC_LEADERBOARD_HIVES" )
			}
		},
		[#f34_local0 + 1] = {
			type = "UIGenericButton",
			id = "by_aliens_revives_button_id",
			properties = {
				leaderboardType = "AlienRevives",
				filterType = "Friends",
				button_text = Engine.Localize( "@LUA_MENU_REVIVES_CAPS" ),
				button_action_func = LeaderboardAction,
				desc_text = Engine.Localize( "@LUA_MENU_DESC_LEADERBOARD_REVIVES" )
			}
		},
		[#f34_local0 + 1] = {
			type = "UIGenericButton",
			id = "by_aliens_downs_button_id",
			properties = {
				leaderboardType = "AlienDowns",
				filterType = "Friends",
				button_text = Engine.Localize( "@LUA_MENU_DOWNED_CAPS" ),
				button_action_func = LeaderboardAction,
				desc_text = Engine.Localize( "@LUA_MENU_DESC_LEADERBOARD_DOWNED" )
			}
		},
		[#f34_local0 + 1] = {
			type = "UIGenericButton",
			id = "by_aliens_challenges_button_id",
			properties = {
				leaderboardType = "AlienChallenges",
				filterType = "Friends",
				button_text = Engine.Localize( "@LUA_MENU_CHALLENGES_COMPLETED_CAPS" ),
				button_action_func = LeaderboardAction,
				desc_text = Engine.Localize( "@LUA_MENU_DESC_LEADERBOARD_CHALLENGE" )
			}
		},
		[#f34_local0 + 1] = {
			type = "UIGenericButton",
			id = "by_aliens_cashflow_button_id",
			properties = {
				leaderboardType = "AlienCashFlow",
				filterType = "Friends",
				button_text = Engine.Localize( "@LUA_MENU_CASHFLOW_CAPS" ),
				button_action_func = LeaderboardAction,
				desc_text = Engine.Localize( "@LUA_MENU_DESC_LEADERBOARD_CASHFLOW" )
			}
		}
	}
	return f34_local0
end

function LeaderboardsSelectionAlienChaosGlobalFeeder( f35_arg0 )
	local f35_local0 = nil
	local f35_local1 = LUI.Alignment.Right
	f35_local0 = {
		[#f35_local0 + 1] = {
			type = "UIGenericButton",
			id = "by_aliens_chaos_score_button_id",
			properties = {
				leaderboardType = "AlienChaosSolo",
				filterType = "Friends",
				button_text = Engine.Localize( "@LUA_MENU_MP_LEADERBOARD_CHAOS_SOLO_CAPS" ),
				button_action_func = LeaderboardAction,
				desc_text = Engine.Localize( "@LUA_MENU_MP_DESC_LEADERBOARD_CHAOS_SOLO" )
			}
		},
		[#f35_local0 + 1] = {
			type = "UIGenericButton",
			id = "by_aliens_chaos_kills_button_id",
			properties = {
				leaderboardType = "AlienChaosCoop",
				filterType = "Friends",
				button_text = Engine.Localize( "@LUA_MENU_MP_LEADERBOARD_CHAOS_COOP_CAPS" ),
				button_action_func = LeaderboardAction,
				desc_text = Engine.Localize( "@LUA_MENU_MP_DESC_LEADERBOARD_CHAOS_COOP" )
			}
		}
	}
	return f35_local0
end

function LeaderboardsSelectionAlienExPOCFeeder( f36_arg0 )
	local f36_local0 = nil
	local f36_local1 = LUI.Alignment.Right
	f36_local0 = {
		[#f36_local0 + 1] = {
			type = "UIGenericButton",
			id = "by_aliens_townsolo_button_id",
			properties = {
				leaderboardType = "AlienTownSolo",
				filterType = "Friends",
				button_text = Engine.Localize( "@LUA_MENU_POC_SOLO_CAPS" ),
				button_action_func = LeaderboardAction,
				desc_text = Engine.Localize( "@LUA_MENU_DESC_LEADERBOARD_POC_SOLO" )
			}
		},
		[#f36_local0 + 1] = {
			type = "UIGenericButton",
			id = "by_aliens_towncoop_button_id",
			properties = {
				leaderboardType = "AlienTownCoop",
				filterType = "Friends",
				button_text = Engine.Localize( "@LUA_MENU_POC_COOP_CAPS" ),
				button_action_func = LeaderboardAction,
				desc_text = Engine.Localize( "@LUA_MENU_DESC_LEADERBOARD_POC_COOP" )
			}
		},
		[#f36_local0 + 1] = {
			type = "UIGenericButton",
			id = "by_aliens_townescapes_button_id",
			properties = {
				leaderboardType = "AlienTownEscapes",
				filterType = "Friends",
				button_text = Engine.Localize( "@LUA_MENU_POC_ESCAPES_CAPS" ),
				button_action_func = LeaderboardAction,
				desc_text = Engine.Localize( "@LUA_MENU_DESC_LEADERBOARD_POC_ESCAPES" )
			}
		}
	}
	return f36_local0
end

function LeaderboardsSelectionAlienExNightfallFeeder( f37_arg0 )
	local f37_local0 = nil
	local f37_local1 = LUI.Alignment.Right
	f37_local0 = {
		[#f37_local0 + 1] = {
			type = "UIGenericButton",
			id = "by_aliens_armorysolo_button_id",
			properties = {
				leaderboardType = "AlienArmorySolo",
				filterType = "Friends",
				button_text = Engine.Localize( "@LUA_MENU_NIGHTFALL_SOLO_CAPS" ),
				button_action_func = LeaderboardAction,
				desc_text = Engine.Localize( "@LUA_MENU_DESC_LEADERBOARD_NIGHTFALL_SOLO" )
			}
		},
		[#f37_local0 + 1] = {
			type = "UIGenericButton",
			id = "by_aliens_armorycoop_button_id",
			properties = {
				leaderboardType = "AlienArmoryCoop",
				filterType = "Friends",
				button_text = Engine.Localize( "@LUA_MENU_NIGHTFALL_COOP_CAPS" ),
				button_action_func = LeaderboardAction,
				desc_text = Engine.Localize( "@LUA_MENU_DESC_LEADERBOARD_NIGHTFALL_COOP" )
			}
		},
		[#f37_local0 + 1] = {
			type = "UIGenericButton",
			id = "by_aliens_armoryescapes_button_id",
			properties = {
				leaderboardType = "AlienArmoryEscapes",
				filterType = "Friends",
				button_text = Engine.Localize( "@LUA_MENU_NIGHTFALL_ESCAPES_CAPS" ),
				button_action_func = LeaderboardAction,
				desc_text = Engine.Localize( "@LUA_MENU_DESC_LEADERBOARD_NIGHTFALL_ESCAPES" )
			}
		}
	}
	return f37_local0
end

function LeaderboardsSelectionAlienExMaydayFeeder( f38_arg0 )
	local f38_local0 = nil
	local f38_local1 = LUI.Alignment.Right
	f38_local0 = {}
	if Engine.GetDvarBool( "extinction_map_selection_enabled" ) then
		f38_local0[#f38_local0 + 1] = {
			type = "UIGenericButton",
			id = "by_aliens_beaconsolo_button_id",
			properties = {
				leaderboardType = "AlienBeaconSolo",
				filterType = "Friends",
				button_text = Engine.Localize( "@LUA_MENU_MP_LEADERBOARD_MAYDAY_SOLO_CAPS" ),
				button_action_func = LeaderboardAction,
				desc_text = Engine.Localize( "@LUA_MENU_MP_DESC_LEADERBOARD_MAYDAY_SOLO" )
			}
		}
		f38_local0[#f38_local0 + 1] = {
			type = "UIGenericButton",
			id = "by_aliens_beaconcoop_button_id",
			properties = {
				leaderboardType = "AlienBeaconCoop",
				filterType = "Friends",
				button_text = Engine.Localize( "@LUA_MENU_MP_LEADERBOARD_MAYDAY_COOP_CAPS" ),
				button_action_func = LeaderboardAction,
				desc_text = Engine.Localize( "@LUA_MENU_MP_DESC_LEADERBOARD_MAYDAY_COOP" )
			}
		}
		f38_local0[#f38_local0 + 1] = {
			type = "UIGenericButton",
			id = "by_aliens_beaconescapes_button_id",
			properties = {
				leaderboardType = "AlienBeaconEscapes",
				filterType = "Friends",
				button_text = Engine.Localize( "@LUA_MENU_MP_LEADERBOARD_MAYDAY_ESCAPES_CAPS" ),
				button_action_func = LeaderboardAction,
				desc_text = Engine.Localize( "@LUA_MENU_MP_DESC_LEADERBOARD_MAYDAY_ESCAPES" )
			}
		}
	end
	return f38_local0
end

function LeaderboardsSelectionAlienExDlc3Feeder( f39_arg0 )
	local f39_local0 = nil
	local f39_local1 = LUI.Alignment.Right
	f39_local0 = {}
	if Engine.GetDvarBool( "extinction_map_selection_enabled" ) then
		f39_local0[#f39_local0 + 1] = {
			type = "UIGenericButton",
			id = "by_aliens_dlc3solo_button_id",
			properties = {
				leaderboardType = "AlienDlc3Solo",
				filterType = "Friends",
				button_text = Engine.Localize( "@LUA_MENU_MP_LEADERBOARD_DLC3_SOLO_CAPS" ),
				button_action_func = LeaderboardAction,
				desc_text = Engine.Localize( "@LUA_MENU_MP_DESC_LEADERBOARD_DLC3_SOLO" )
			}
		}
		f39_local0[#f39_local0 + 1] = {
			type = "UIGenericButton",
			id = "by_aliens_dlc3coop_button_id",
			properties = {
				leaderboardType = "AlienDlc3Coop",
				filterType = "Friends",
				button_text = Engine.Localize( "@LUA_MENU_MP_LEADERBOARD_DLC3_COOP_CAPS" ),
				button_action_func = LeaderboardAction,
				desc_text = Engine.Localize( "@LUA_MENU_MP_DESC_LEADERBOARD_DLC3_COOP" )
			}
		}
		f39_local0[#f39_local0 + 1] = {
			type = "UIGenericButton",
			id = "by_aliens_dlc3escapes_button_id",
			properties = {
				leaderboardType = "AlienDlc3Escapes",
				filterType = "Friends",
				button_text = Engine.Localize( "@LUA_MENU_MP_LEADERBOARD_DLC3_ESCAPES_CAPS" ),
				button_action_func = LeaderboardAction,
				desc_text = Engine.Localize( "@LUA_MENU_MP_DESC_LEADERBOARD_DLC3_ESCAPES" )
			}
		}
	end
	return f39_local0
end

function LeaderboardsSelectionAlienExLastFeeder( f40_arg0 )
	local f40_local0 = nil
	local f40_local1 = LUI.Alignment.Right
	f40_local0 = {}
	if Engine.GetDvarBool( "extinction_map_selection_enabled" ) then
		f40_local0[#f40_local0 + 1] = {
			type = "UIGenericButton",
			id = "by_aliens_lastsolo_button_id",
			properties = {
				leaderboardType = "AlienLastSolo",
				filterType = "Friends",
				button_text = Engine.Localize( "@LUA_MENU_MP_LEADERBOARD_LAST_SOLO_CAPS" ),
				button_action_func = LeaderboardAction,
				desc_text = Engine.Localize( "@LUA_MENU_MP_DESC_LEADERBOARD_LAST_SOLO" )
			}
		}
		f40_local0[#f40_local0 + 1] = {
			type = "UIGenericButton",
			id = "by_aliens_lastcoop_button_id",
			properties = {
				leaderboardType = "AlienLastCoop",
				filterType = "Friends",
				button_text = Engine.Localize( "@LUA_MENU_MP_LEADERBOARD_LAST_COOP_CAPS" ),
				button_action_func = LeaderboardAction,
				desc_text = Engine.Localize( "@LUA_MENU_MP_DESC_LEADERBOARD_LAST_COOP" )
			}
		}
		f40_local0[#f40_local0 + 1] = {
			type = "UIGenericButton",
			id = "by_aliens_lastescapes_button_id",
			properties = {
				leaderboardType = "AlienLastEscapes",
				filterType = "Friends",
				button_text = Engine.Localize( "@LUA_MENU_MP_LEADERBOARD_LAST_ESCAPES_CAPS" ),
				button_action_func = LeaderboardAction,
				desc_text = Engine.Localize( "@LUA_MENU_MP_DESC_LEADERBOARD_LAST_ESCAPES" )
			}
		}
	end
	return f40_local0
end

function LeaderboardsSelectionAlienChaosPOCFeeder( f41_arg0 )
	local f41_local0 = nil
	local f41_local1 = LUI.Alignment.Right
	f41_local0 = {
		[#f41_local0 + 1] = {
			type = "UIGenericButton",
			id = "by_aliens_townsolo_button_id",
			properties = {
				leaderboardType = "AlienTownChaosSolo",
				filterType = "Friends",
				button_text = Engine.Localize( "@LUA_MENU_POC_SOLO_CAPS" ),
				button_action_func = LeaderboardAction,
				desc_text = Engine.Localize( "@LUA_MENU_MP_DESC_LEADERBOARD_CHAOS_POC_SOLO" )
			}
		},
		[#f41_local0 + 1] = {
			type = "UIGenericButton",
			id = "by_aliens_towncoop_button_id",
			properties = {
				leaderboardType = "AlienTownChaosCoop",
				filterType = "Friends",
				button_text = Engine.Localize( "@LUA_MENU_POC_COOP_CAPS" ),
				button_action_func = LeaderboardAction,
				desc_text = Engine.Localize( "@LUA_MENU_MP_DESC_LEADERBOARD_CHAOS_POC_COOP" )
			}
		}
	}
	return f41_local0
end

function LeaderboardsSelectionAlienChaosNightfallFeeder( f42_arg0 )
	local f42_local0 = nil
	local f42_local1 = LUI.Alignment.Right
	f42_local0 = {
		[#f42_local0 + 1] = {
			type = "UIGenericButton",
			id = "by_aliens_armorysolo_button_id",
			properties = {
				leaderboardType = "AlienArmoryChaosSolo",
				filterType = "Friends",
				button_text = Engine.Localize( "@LUA_MENU_NIGHTFALL_SOLO_CAPS" ),
				button_action_func = LeaderboardAction,
				desc_text = Engine.Localize( "@LUA_MENU_MP_DESC_LEADERBOARD_CHAOS_NIGHTFALL_SOLO" )
			}
		},
		[#f42_local0 + 1] = {
			type = "UIGenericButton",
			id = "by_aliens_armorycoop_button_id",
			properties = {
				leaderboardType = "AlienArmoryChaosCoop",
				filterType = "Friends",
				button_text = Engine.Localize( "@LUA_MENU_NIGHTFALL_COOP_CAPS" ),
				button_action_func = LeaderboardAction,
				desc_text = Engine.Localize( "@LUA_MENU_MP_DESC_LEADERBOARD_CHAOS_NIGHTFALL_COOP" )
			}
		}
	}
	return f42_local0
end

function LeaderboardsSelectionAlienChaosMaydayFeeder( f43_arg0 )
	local f43_local0 = nil
	local f43_local1 = LUI.Alignment.Right
	f43_local0 = {}
	if Engine.GetDvarBool( "extinction_map_selection_enabled" ) then
		f43_local0[#f43_local0 + 1] = {
			type = "UIGenericButton",
			id = "by_aliens_beaconsolo_button_id",
			properties = {
				leaderboardType = "AlienBeaconChaosSolo",
				filterType = "Friends",
				button_text = Engine.Localize( "@LUA_MENU_MP_LEADERBOARD_MAYDAY_SOLO_CAPS" ),
				button_action_func = LeaderboardAction,
				desc_text = Engine.Localize( "@LUA_MENU_MP_DESC_LEADERBOARD_CHAOS_MAYDAY_SOLO" )
			}
		}
		f43_local0[#f43_local0 + 1] = {
			type = "UIGenericButton",
			id = "by_aliens_beaconcoop_button_id",
			properties = {
				leaderboardType = "AlienBeaconChaosCoop",
				filterType = "Friends",
				button_text = Engine.Localize( "@LUA_MENU_MP_LEADERBOARD_MAYDAY_COOP_CAPS" ),
				button_action_func = LeaderboardAction,
				desc_text = Engine.Localize( "@LUA_MENU_MP_DESC_LEADERBOARD_CHAOS_MAYDAY_COOP" )
			}
		}
	end
	return f43_local0
end

function LeaderboardsSelectionAlienChaosDlc3Feeder( f44_arg0 )
	local f44_local0 = nil
	local f44_local1 = LUI.Alignment.Right
	f44_local0 = {}
	if Engine.GetDvarBool( "extinction_map_selection_enabled" ) then
		f44_local0[#f44_local0 + 1] = {
			type = "UIGenericButton",
			id = "by_aliens_dlc3solo_button_id",
			properties = {
				leaderboardType = "AlienDlc3ChaosSolo",
				filterType = "Friends",
				button_text = Engine.Localize( "@LUA_MENU_MP_LEADERBOARD_DLC3_SOLO_CAPS" ),
				button_action_func = LeaderboardAction,
				desc_text = Engine.Localize( "@LUA_MENU_MP_DESC_LEADERBOARD_CHAOS_DLC3_SOLO" )
			}
		}
		f44_local0[#f44_local0 + 1] = {
			type = "UIGenericButton",
			id = "by_aliens_dlc3coop_button_id",
			properties = {
				leaderboardType = "AlienDlc3ChaosCoop",
				filterType = "Friends",
				button_text = Engine.Localize( "@LUA_MENU_MP_LEADERBOARD_DLC3_COOP_CAPS" ),
				button_action_func = LeaderboardAction,
				desc_text = Engine.Localize( "@LUA_MENU_MP_DESC_LEADERBOARD_CHAOS_DLC3_COOP" )
			}
		}
	end
	return f44_local0
end

function LeaderboardsSelectionAlienChaosLastFeeder( f45_arg0 )
	local f45_local0 = nil
	local f45_local1 = LUI.Alignment.Right
	f45_local0 = {}
	if Engine.GetDvarBool( "extinction_map_selection_enabled" ) then
		f45_local0[#f45_local0 + 1] = {
			type = "UIGenericButton",
			id = "by_aliens_dlc3solo_button_id",
			properties = {
				leaderboardType = "AlienLastChaosSolo",
				filterType = "Friends",
				button_text = Engine.Localize( "@LUA_MENU_MP_LEADERBOARD_LAST_SOLO_CAPS" ),
				button_action_func = LeaderboardAction,
				desc_text = Engine.Localize( "@LUA_MENU_MP_DESC_LEADERBOARD_CHAOS_LAST_SOLO" )
			}
		}
		f45_local0[#f45_local0 + 1] = {
			type = "UIGenericButton",
			id = "by_aliens_lastcoop_button_id",
			properties = {
				leaderboardType = "AlienLastChaosCoop",
				filterType = "Friends",
				button_text = Engine.Localize( "@LUA_MENU_MP_LEADERBOARD_LAST_COOP_CAPS" ),
				button_action_func = LeaderboardAction,
				desc_text = Engine.Localize( "@LUA_MENU_MP_DESC_LEADERBOARD_CHAOS_LAST_COOP" )
			}
		}
	end
	return f45_local0
end

function LeaderboardsMainCreate( f46_arg0, f46_arg1 )
	f46_arg0:dispatchEventToRoot( {
		name = "add_button_helper_text",
		button_ref = "button_secondary",
		helper_text = Engine.Localize( "@LUA_MENU_BACK" ),
		side = "left",
		clickable = true
	} )
end

function leaderboards()
	return {
		type = "UIElement",
		id = "leaderboards_menu_id",
		states = {
			default = {
				topAnchor = true,
				bottomAnchor = true,
				leftAnchor = true,
				rightAnchor = true,
				top = 0,
				bottom = 0,
				left = 0,
				right = 0
			}
		},
		handlers = {
			menu_create = LeaderboardsMainCreate
		},
		children = {
			{
				type = "generic_menu_title",
				properties = {
					menu_title = Engine.Localize( "@LUA_MENU_LEADERBOARDS_CAPS" )
				}
			},
			{
				type = "leaderboards_selection_vlist",
				id = "leaderboards_selection_vlist_id"
			},
			{
				type = "button_desc_text",
				id = "button_info_text",
				states = {
					default = {
						topAnchor = true,
						bottomAnchor = false,
						leftAnchor = true,
						rightAnchor = false,
						top = GenericMenuDims.menu_bottom_scroll + 60,
						bottom = GenericMenuDims.menu_bottom_scroll + 60 + CoD.TextSettings.SmallFont.Height,
						left = 0,
						right = GenericMenuDims.menu_right
					}
				}
			},
			{
				type = "button_helper_text_main",
				id = "leaderboards_button_helper_text_id"
			},
			{
				type = "online_friends_widget",
				id = "online_friends_widget_id"
			},
			{
				type = "generic_back_button"
			}
		}
	}
end

function LeaderboardMenuFactory( f48_arg0, f48_arg1, f48_arg2 )
	return function ()
		return {
			type = "UIElement",
			id = "leaderboards_" .. f48_arg1,
			states = {
				default = {
					topAnchor = true,
					bottomAnchor = true,
					leftAnchor = true,
					rightAnchor = true,
					top = 0,
					bottom = 0,
					left = 0,
					right = 0
				}
			},
			handlers = {
				menu_create = LeaderboardsMainCreate
			},
			children = {
				{
					type = "generic_menu_title",
					properties = {
						menu_title = f48_arg2 and Engine.Localize( f48_arg2 ) or Engine.Localize( "@LUA_MENU_LEADERBOARDS_CAPS" )
					}
				},
				{
					type = f48_arg0,
					id = theID
				},
				{
					type = "button_desc_text",
					id = "button_info_text",
					states = {
						default = {
							topAnchor = true,
							bottomAnchor = false,
							leftAnchor = true,
							rightAnchor = false,
							top = GenericMenuDims.menu_bottom_scroll + 60,
							bottom = GenericMenuDims.menu_bottom_scroll + 60 + CoD.TextSettings.SmallFont.Height,
							left = 0,
							right = GenericMenuDims.menu_right
						}
					}
				},
				{
					type = "button_helper_text_main",
					id = "leaderboards_button_helper_text_id"
				},
				{
					type = "online_friends_widget",
					id = "online_friends_widget_id"
				},
				{
					type = "generic_back_button"
				}
			}
		}
	end
	
end

LUI.MenuBuilder.registerDef( "leaderboards_alien_extinction_selection_vlist", leaderboards_alien_extinction_selection_vlist )
LUI.MenuBuilder.registerDef( "leaderboards_alien_chaos_selection_vlist", leaderboards_alien_chaos_selection_vlist )
LUI.MenuBuilder.registerDef( "leaderboards_alien_ex_global_selection_vlist", leaderboards_alien_ex_global_selection_vlist )
LUI.MenuBuilder.registerDef( "leaderboards_alien_chaos_global_selection_vlist", leaderboards_alien_chaos_global_selection_vlist )
LUI.MenuBuilder.registerDef( "leaderboards_alien_ex_poc_selection_vlist", leaderboards_alien_ex_poc_selection_vlist )
LUI.MenuBuilder.registerDef( "leaderboards_alien_chaos_poc_selection_vlist", leaderboards_alien_chaos_poc_selection_vlist )
LUI.MenuBuilder.registerDef( "leaderboards_alien_ex_nightfall_selection_vlist", leaderboards_alien_ex_nightfall_selection_vlist )
LUI.MenuBuilder.registerDef( "leaderboards_alien_chaos_nightfall_selection_vlist", leaderboards_alien_chaos_nightfall_selection_vlist )
LUI.MenuBuilder.registerDef( "leaderboards_alien_ex_mayday_selection_vlist", leaderboards_alien_ex_mayday_selection_vlist )
LUI.MenuBuilder.registerDef( "leaderboards_alien_chaos_mayday_selection_vlist", leaderboards_alien_chaos_mayday_selection_vlist )
LUI.MenuBuilder.registerDef( "leaderboards_alien_ex_dlc3_selection_vlist", leaderboards_alien_ex_dlc3_selection_vlist )
LUI.MenuBuilder.registerDef( "leaderboards_alien_chaos_dlc3_selection_vlist", leaderboards_alien_chaos_dlc3_selection_vlist )
LUI.MenuBuilder.registerDef( "leaderboards_alien_ex_last_selection_vlist", leaderboards_alien_ex_last_selection_vlist )
LUI.MenuBuilder.registerDef( "leaderboards_alien_chaos_last_selection_vlist", leaderboards_alien_chaos_last_selection_vlist )
LUI.MenuBuilder.registerDef( "leaderboards_selection_vlist", leaderboards_selection_vlist )
LUI.MenuBuilder.registerDef( "leaderboards", leaderboards )
LUI.MenuBuilder.registerDef( "leaderboards_alien_extinction", LeaderboardMenuFactory( "leaderboards_alien_extinction_selection_vlist", "leaderboards_alien_extinction_selection_vlist_id" ) )
LUI.MenuBuilder.registerDef( "leaderboards_alien_chaos", LeaderboardMenuFactory( "leaderboards_alien_chaos_selection_vlist", "leaderboards_alien_chaos_selection_vlist_id", "@LUA_MENU_MP_LEADERBOARDS_CAPS_CHAOS" ) )
LUI.MenuBuilder.registerDef( "leaderboards_alien_ex_global", LeaderboardMenuFactory( "leaderboards_alien_ex_global_selection_vlist", "leaderboards_alien_ex_global_selection_vlist_id" ) )
LUI.MenuBuilder.registerDef( "leaderboards_alien_chaos_global", LeaderboardMenuFactory( "leaderboards_alien_chaos_global_selection_vlist", "leaderboards_alien_chaos_global_selection_vlist_id", "@LUA_MENU_MP_LEADERBOARDS_CAPS_CHAOS" ) )
LUI.MenuBuilder.registerDef( "leaderboards_alien_ex_poc", LeaderboardMenuFactory( "leaderboards_alien_ex_poc_selection_vlist", "leaderboards_alien_extinction_poc_selection_vlist_id" ) )
LUI.MenuBuilder.registerDef( "leaderboards_alien_chaos_poc", LeaderboardMenuFactory( "leaderboards_alien_chaos_poc_selection_vlist", "leaderboards_alien_chaos_poc_selection_vlist_id", "@LUA_MENU_MP_LEADERBOARDS_CAPS_CHAOS" ) )
LUI.MenuBuilder.registerDef( "leaderboards_alien_ex_nightfall", LeaderboardMenuFactory( "leaderboards_alien_ex_nightfall_selection_vlist", "leaderboards_alien_extinction_nightfall_selection_vlist_id" ) )
LUI.MenuBuilder.registerDef( "leaderboards_alien_chaos_nightfall", LeaderboardMenuFactory( "leaderboards_alien_chaos_nightfall_selection_vlist", "leaderboards_alien_chaos_nightfall_selection_vlist_id", "@LUA_MENU_MP_LEADERBOARDS_CAPS_CHAOS" ) )
LUI.MenuBuilder.registerDef( "leaderboards_alien_ex_mayday", LeaderboardMenuFactory( "leaderboards_alien_ex_mayday_selection_vlist", "leaderboards_alien_extinction_mayday_selection_vlist_id" ) )
LUI.MenuBuilder.registerDef( "leaderboards_alien_chaos_mayday", LeaderboardMenuFactory( "leaderboards_alien_chaos_mayday_selection_vlist", "leaderboards_alien_chaos_mayday_selection_vlist_id", "@LUA_MENU_MP_LEADERBOARDS_CAPS_CHAOS" ) )
LUI.MenuBuilder.registerDef( "leaderboards_alien_ex_dlc3", LeaderboardMenuFactory( "leaderboards_alien_ex_dlc3_selection_vlist", "leaderboards_alien_extinction_dlc3_selection_vlist_id" ) )
LUI.MenuBuilder.registerDef( "leaderboards_alien_chaos_dlc3", LeaderboardMenuFactory( "leaderboards_alien_chaos_dlc3_selection_vlist", "leaderboards_alien_chaos_dlc3_selection_vlist_id", "@LUA_MENU_MP_LEADERBOARDS_CAPS_CHAOS" ) )
LUI.MenuBuilder.registerDef( "leaderboards_alien_ex_last", LeaderboardMenuFactory( "leaderboards_alien_ex_last_selection_vlist", "leaderboards_alien_extinction_last_selection_vlist_id" ) )
LUI.MenuBuilder.registerDef( "leaderboards_alien_chaos_last", LeaderboardMenuFactory( "leaderboards_alien_chaos_last_selection_vlist", "leaderboards_alien_chaos_last_selection_vlist_id", "@LUA_MENU_MP_LEADERBOARDS_CAPS_CHAOS" ) )
LockTable( _M )
